# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr
from typing import Any, List
from typing_extensions import Annotated
from dima_sdk.models.delete401k_enrollments_definition_request import Delete401kEnrollmentsDefinitionRequest
from dima_sdk.models.get401k_enrollments_definition200_response_inner import Get401kEnrollmentsDefinition200ResponseInner
from dima_sdk.models.post401k_enrollments_definition200_response import Post401kEnrollmentsDefinition200Response
from dima_sdk.models.post401k_enrollments_definition_request import Post401kEnrollmentsDefinitionRequest
from dima_sdk.models.put401k_enrollments_definition200_response import Put401kEnrollmentsDefinition200Response
from dima_sdk.models.put401k_enrollments_definition_request import Put401kEnrollmentsDefinitionRequest

from dima_sdk.api_client import ApiClient, RequestSerialized
from dima_sdk.api_response import ApiResponse
from dima_sdk.rest import RESTResponseType


class EnrollmentsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def delete401k_enrollments_definition(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        delete401k_enrollments_definition_request: Delete401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> object:
        """Delete enrollment settings from an employee in a 401k plan

        Delete enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param delete401k_enrollments_definition_request: (required)
        :type delete401k_enrollments_definition_request: Delete401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            delete401k_enrollments_definition_request=delete401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': "object",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def delete401k_enrollments_definition_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        delete401k_enrollments_definition_request: Delete401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[object]:
        """Delete enrollment settings from an employee in a 401k plan

        Delete enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param delete401k_enrollments_definition_request: (required)
        :type delete401k_enrollments_definition_request: Delete401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            delete401k_enrollments_definition_request=delete401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': "object",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def delete401k_enrollments_definition_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        delete401k_enrollments_definition_request: Delete401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Delete enrollment settings from an employee in a 401k plan

        Delete enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param delete401k_enrollments_definition_request: (required)
        :type delete401k_enrollments_definition_request: Delete401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            delete401k_enrollments_definition_request=delete401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': "object",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _delete401k_enrollments_definition_serialize(
        self,
        id,
        contract_id,
        plan_id,
        delete401k_enrollments_definition_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        if contract_id is not None:
            _path_params['contract_id'] = contract_id
        if plan_id is not None:
            _path_params['plan_id'] = plan_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if delete401k_enrollments_definition_request is not None:
            _body_params = delete401k_enrollments_definition_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'deelToken', 
            'oauth2'
        ]

        return self.api_client.param_serialize(
            method='DELETE',
            resource_path='/benefits/legal-entities/{id}/contracts/{contract_id}/plans/{plan_id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def get401k_enrollments_definition(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> List[Get401kEnrollmentsDefinition200ResponseInner]:
        """Get enrollment settings from an employee in a 401k plan

        Get enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:read`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[Get401kEnrollmentsDefinition200ResponseInner]",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get401k_enrollments_definition_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[List[Get401kEnrollmentsDefinition200ResponseInner]]:
        """Get enrollment settings from an employee in a 401k plan

        Get enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:read`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[Get401kEnrollmentsDefinition200ResponseInner]",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get401k_enrollments_definition_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get enrollment settings from an employee in a 401k plan

        Get enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:read`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[Get401kEnrollmentsDefinition200ResponseInner]",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get401k_enrollments_definition_serialize(
        self,
        id,
        contract_id,
        plan_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        if contract_id is not None:
            _path_params['contract_id'] = contract_id
        if plan_id is not None:
            _path_params['plan_id'] = plan_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'deelToken', 
            'oauth2'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/benefits/legal-entities/{id}/contracts/{contract_id}/plans/{plan_id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def post401k_enrollments_definition(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        post401k_enrollments_definition_request: Post401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Post401kEnrollmentsDefinition200Response:
        """Enroll an employee in a 401k plan

        Enroll an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param post401k_enrollments_definition_request: (required)
        :type post401k_enrollments_definition_request: Post401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._post401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            post401k_enrollments_definition_request=post401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Post401kEnrollmentsDefinition200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def post401k_enrollments_definition_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        post401k_enrollments_definition_request: Post401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Post401kEnrollmentsDefinition200Response]:
        """Enroll an employee in a 401k plan

        Enroll an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param post401k_enrollments_definition_request: (required)
        :type post401k_enrollments_definition_request: Post401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._post401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            post401k_enrollments_definition_request=post401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Post401kEnrollmentsDefinition200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def post401k_enrollments_definition_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        post401k_enrollments_definition_request: Post401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Enroll an employee in a 401k plan

        Enroll an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param post401k_enrollments_definition_request: (required)
        :type post401k_enrollments_definition_request: Post401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._post401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            post401k_enrollments_definition_request=post401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Post401kEnrollmentsDefinition200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _post401k_enrollments_definition_serialize(
        self,
        id,
        contract_id,
        plan_id,
        post401k_enrollments_definition_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        if contract_id is not None:
            _path_params['contract_id'] = contract_id
        if plan_id is not None:
            _path_params['plan_id'] = plan_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if post401k_enrollments_definition_request is not None:
            _body_params = post401k_enrollments_definition_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'deelToken', 
            'oauth2'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/benefits/legal-entities/{id}/contracts/{contract_id}/plans/{plan_id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def put401k_enrollments_definition(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        put401k_enrollments_definition_request: Put401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Put401kEnrollmentsDefinition200Response:
        """Change enrollment settings from an employee in a 401k plan

        Change enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param put401k_enrollments_definition_request: (required)
        :type put401k_enrollments_definition_request: Put401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._put401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            put401k_enrollments_definition_request=put401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Put401kEnrollmentsDefinition200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def put401k_enrollments_definition_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        put401k_enrollments_definition_request: Put401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Put401kEnrollmentsDefinition200Response]:
        """Change enrollment settings from an employee in a 401k plan

        Change enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param put401k_enrollments_definition_request: (required)
        :type put401k_enrollments_definition_request: Put401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._put401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            put401k_enrollments_definition_request=put401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Put401kEnrollmentsDefinition200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def put401k_enrollments_definition_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="Legal entity id which employee/contract belongs")],
        contract_id: Annotated[StrictStr, Field(description="Contract id from the employee")],
        plan_id: Annotated[StrictStr, Field(description="Plan id to enroll the employee into")],
        put401k_enrollments_definition_request: Put401kEnrollmentsDefinitionRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Change enrollment settings from an employee in a 401k plan

        Change enrollment settings from an employee in a 401k plan  **Token scopes**: `benefits:write`

        :param id: Legal entity id which employee/contract belongs (required)
        :type id: str
        :param contract_id: Contract id from the employee (required)
        :type contract_id: str
        :param plan_id: Plan id to enroll the employee into (required)
        :type plan_id: str
        :param put401k_enrollments_definition_request: (required)
        :type put401k_enrollments_definition_request: Put401kEnrollmentsDefinitionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._put401k_enrollments_definition_serialize(
            id=id,
            contract_id=contract_id,
            plan_id=plan_id,
            put401k_enrollments_definition_request=put401k_enrollments_definition_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Put401kEnrollmentsDefinition200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _put401k_enrollments_definition_serialize(
        self,
        id,
        contract_id,
        plan_id,
        put401k_enrollments_definition_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        if contract_id is not None:
            _path_params['contract_id'] = contract_id
        if plan_id is not None:
            _path_params['plan_id'] = plan_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if put401k_enrollments_definition_request is not None:
            _body_params = put401k_enrollments_definition_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'deelToken', 
            'oauth2'
        ]

        return self.api_client.param_serialize(
            method='PUT',
            resource_path='/benefits/legal-entities/{id}/contracts/{contract_id}/plans/{plan_id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


