# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictInt, StrictStr, field_validator
from typing import List, Optional
from typing_extensions import Annotated
from dima_sdk.models.get_benefit_paystubs200_response import GetBenefitPaystubs200Response

from dima_sdk.api_client import ApiClient, RequestSerialized
from dima_sdk.api_response import ApiResponse
from dima_sdk.rest import RESTResponseType


class PaystubsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def get_benefit_paystubs(
        self,
        legal_entity_id: Annotated[StrictStr, Field(description="Id from the legal entity to fetch data")],
        states: Annotated[Optional[List[StrictStr]], Field(description="Payroll states: OPEN | LOCKED | CLOSED (OPEN doesn't have `employees` info)")] = None,
        date_start: Annotated[Optional[StrictStr], Field(description="Start date to fectch the paystubs from")] = None,
        date_end: Annotated[Optional[StrictStr], Field(description="End date to fectch the paystubs")] = None,
        items_per_page: Annotated[Optional[StrictInt], Field(description="Items per page")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="The last fetched id to start querying from")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> GetBenefitPaystubs200Response:
        """Get paystubs from legal entity integrated with external benefits vendor

        Get paystubs from legal entity integrated with external benefits vendor  **Token scopes**: `benefits:read`

        :param legal_entity_id: Id from the legal entity to fetch data (required)
        :type legal_entity_id: str
        :param states: Payroll states: OPEN | LOCKED | CLOSED (OPEN doesn't have `employees` info)
        :type states: List[str]
        :param date_start: Start date to fectch the paystubs from
        :type date_start: str
        :param date_end: End date to fectch the paystubs
        :type date_end: str
        :param items_per_page: Items per page
        :type items_per_page: int
        :param cursor: The last fetched id to start querying from
        :type cursor: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_benefit_paystubs_serialize(
            legal_entity_id=legal_entity_id,
            states=states,
            date_start=date_start,
            date_end=date_end,
            items_per_page=items_per_page,
            cursor=cursor,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "GetBenefitPaystubs200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_benefit_paystubs_with_http_info(
        self,
        legal_entity_id: Annotated[StrictStr, Field(description="Id from the legal entity to fetch data")],
        states: Annotated[Optional[List[StrictStr]], Field(description="Payroll states: OPEN | LOCKED | CLOSED (OPEN doesn't have `employees` info)")] = None,
        date_start: Annotated[Optional[StrictStr], Field(description="Start date to fectch the paystubs from")] = None,
        date_end: Annotated[Optional[StrictStr], Field(description="End date to fectch the paystubs")] = None,
        items_per_page: Annotated[Optional[StrictInt], Field(description="Items per page")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="The last fetched id to start querying from")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[GetBenefitPaystubs200Response]:
        """Get paystubs from legal entity integrated with external benefits vendor

        Get paystubs from legal entity integrated with external benefits vendor  **Token scopes**: `benefits:read`

        :param legal_entity_id: Id from the legal entity to fetch data (required)
        :type legal_entity_id: str
        :param states: Payroll states: OPEN | LOCKED | CLOSED (OPEN doesn't have `employees` info)
        :type states: List[str]
        :param date_start: Start date to fectch the paystubs from
        :type date_start: str
        :param date_end: End date to fectch the paystubs
        :type date_end: str
        :param items_per_page: Items per page
        :type items_per_page: int
        :param cursor: The last fetched id to start querying from
        :type cursor: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_benefit_paystubs_serialize(
            legal_entity_id=legal_entity_id,
            states=states,
            date_start=date_start,
            date_end=date_end,
            items_per_page=items_per_page,
            cursor=cursor,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "GetBenefitPaystubs200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_benefit_paystubs_without_preload_content(
        self,
        legal_entity_id: Annotated[StrictStr, Field(description="Id from the legal entity to fetch data")],
        states: Annotated[Optional[List[StrictStr]], Field(description="Payroll states: OPEN | LOCKED | CLOSED (OPEN doesn't have `employees` info)")] = None,
        date_start: Annotated[Optional[StrictStr], Field(description="Start date to fectch the paystubs from")] = None,
        date_end: Annotated[Optional[StrictStr], Field(description="End date to fectch the paystubs")] = None,
        items_per_page: Annotated[Optional[StrictInt], Field(description="Items per page")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="The last fetched id to start querying from")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get paystubs from legal entity integrated with external benefits vendor

        Get paystubs from legal entity integrated with external benefits vendor  **Token scopes**: `benefits:read`

        :param legal_entity_id: Id from the legal entity to fetch data (required)
        :type legal_entity_id: str
        :param states: Payroll states: OPEN | LOCKED | CLOSED (OPEN doesn't have `employees` info)
        :type states: List[str]
        :param date_start: Start date to fectch the paystubs from
        :type date_start: str
        :param date_end: End date to fectch the paystubs
        :type date_end: str
        :param items_per_page: Items per page
        :type items_per_page: int
        :param cursor: The last fetched id to start querying from
        :type cursor: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_benefit_paystubs_serialize(
            legal_entity_id=legal_entity_id,
            states=states,
            date_start=date_start,
            date_end=date_end,
            items_per_page=items_per_page,
            cursor=cursor,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "GetBenefitPaystubs200Response",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_benefit_paystubs_serialize(
        self,
        legal_entity_id,
        states,
        date_start,
        date_end,
        items_per_page,
        cursor,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
            'states': 'multi',
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if legal_entity_id is not None:
            _path_params['legalEntityId'] = legal_entity_id
        # process the query parameters
        if states is not None:
            
            _query_params.append(('states', states))
            
        if date_start is not None:
            
            _query_params.append(('date_start', date_start))
            
        if date_end is not None:
            
            _query_params.append(('date_end', date_end))
            
        if items_per_page is not None:
            
            _query_params.append(('items_per_page', items_per_page))
            
        if cursor is not None:
            
            _query_params.append(('cursor', cursor))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'deelToken', 
            'oauth2'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/benefits/legal-entities/{legalEntityId}/paystubs',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


