# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr
from typing import Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.payments_detailed_report_container import PaymentsDetailedReportContainer

from dima_sdk.api_client import ApiClient, RequestSerialized
from dima_sdk.api_response import ApiResponse
from dima_sdk.rest import RESTResponseType


class ReportsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def get_detailed_payments_report(
        self,
        from_date: Annotated[StrictStr, Field(description="Filtered results will include records created on or after the provided date.")],
        to_date: Annotated[StrictStr, Field(description="Filtered results will include records created before the provided date.")],
        limit: Annotated[Optional[Union[Annotated[float, Field(le=99, strict=True, ge=1)], Annotated[int, Field(le=99, strict=True, ge=1)]]], Field(description="Return a page of results with given number of records; NOTE technically ALL query parameters are strings or array of strings")] = None,
        offset: Annotated[Optional[Union[Annotated[float, Field(le=999999999, strict=True, ge=0)], Annotated[int, Field(le=999999999, strict=True, ge=0)]]], Field(description="Return a page of results after given index of row; NOTE technically ALL query parameters are strings or array of strings'")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> PaymentsDetailedReportContainer:
        """Detailed payments report

        Retrieve the detailed payment report in JSON format.

        :param from_date: Filtered results will include records created on or after the provided date. (required)
        :type from_date: str
        :param to_date: Filtered results will include records created before the provided date. (required)
        :type to_date: str
        :param limit: Return a page of results with given number of records; NOTE technically ALL query parameters are strings or array of strings
        :type limit: float
        :param offset: Return a page of results after given index of row; NOTE technically ALL query parameters are strings or array of strings'
        :type offset: float
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_detailed_payments_report_serialize(
            from_date=from_date,
            to_date=to_date,
            limit=limit,
            offset=offset,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "PaymentsDetailedReportContainer",
            '400': "ApiErrorContainer",
            '401': "ApiErrorContainer",
            '403': "ApiErrorContainer",
            '404': "ApiErrorContainer",
            '500': "ApiErrorContainer",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_detailed_payments_report_with_http_info(
        self,
        from_date: Annotated[StrictStr, Field(description="Filtered results will include records created on or after the provided date.")],
        to_date: Annotated[StrictStr, Field(description="Filtered results will include records created before the provided date.")],
        limit: Annotated[Optional[Union[Annotated[float, Field(le=99, strict=True, ge=1)], Annotated[int, Field(le=99, strict=True, ge=1)]]], Field(description="Return a page of results with given number of records; NOTE technically ALL query parameters are strings or array of strings")] = None,
        offset: Annotated[Optional[Union[Annotated[float, Field(le=999999999, strict=True, ge=0)], Annotated[int, Field(le=999999999, strict=True, ge=0)]]], Field(description="Return a page of results after given index of row; NOTE technically ALL query parameters are strings or array of strings'")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[PaymentsDetailedReportContainer]:
        """Detailed payments report

        Retrieve the detailed payment report in JSON format.

        :param from_date: Filtered results will include records created on or after the provided date. (required)
        :type from_date: str
        :param to_date: Filtered results will include records created before the provided date. (required)
        :type to_date: str
        :param limit: Return a page of results with given number of records; NOTE technically ALL query parameters are strings or array of strings
        :type limit: float
        :param offset: Return a page of results after given index of row; NOTE technically ALL query parameters are strings or array of strings'
        :type offset: float
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_detailed_payments_report_serialize(
            from_date=from_date,
            to_date=to_date,
            limit=limit,
            offset=offset,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "PaymentsDetailedReportContainer",
            '400': "ApiErrorContainer",
            '401': "ApiErrorContainer",
            '403': "ApiErrorContainer",
            '404': "ApiErrorContainer",
            '500': "ApiErrorContainer",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_detailed_payments_report_without_preload_content(
        self,
        from_date: Annotated[StrictStr, Field(description="Filtered results will include records created on or after the provided date.")],
        to_date: Annotated[StrictStr, Field(description="Filtered results will include records created before the provided date.")],
        limit: Annotated[Optional[Union[Annotated[float, Field(le=99, strict=True, ge=1)], Annotated[int, Field(le=99, strict=True, ge=1)]]], Field(description="Return a page of results with given number of records; NOTE technically ALL query parameters are strings or array of strings")] = None,
        offset: Annotated[Optional[Union[Annotated[float, Field(le=999999999, strict=True, ge=0)], Annotated[int, Field(le=999999999, strict=True, ge=0)]]], Field(description="Return a page of results after given index of row; NOTE technically ALL query parameters are strings or array of strings'")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Detailed payments report

        Retrieve the detailed payment report in JSON format.

        :param from_date: Filtered results will include records created on or after the provided date. (required)
        :type from_date: str
        :param to_date: Filtered results will include records created before the provided date. (required)
        :type to_date: str
        :param limit: Return a page of results with given number of records; NOTE technically ALL query parameters are strings or array of strings
        :type limit: float
        :param offset: Return a page of results after given index of row; NOTE technically ALL query parameters are strings or array of strings'
        :type offset: float
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_detailed_payments_report_serialize(
            from_date=from_date,
            to_date=to_date,
            limit=limit,
            offset=offset,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "PaymentsDetailedReportContainer",
            '400': "ApiErrorContainer",
            '401': "ApiErrorContainer",
            '403': "ApiErrorContainer",
            '404': "ApiErrorContainer",
            '500': "ApiErrorContainer",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_detailed_payments_report_serialize(
        self,
        from_date,
        to_date,
        limit,
        offset,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if from_date is not None:
            
            _query_params.append(('from_date', from_date))
            
        if to_date is not None:
            
            _query_params.append(('to_date', to_date))
            
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if offset is not None:
            
            _query_params.append(('offset', offset))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'deelToken', 
            'oauth2'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/reports/detailed-payments',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


