# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.amend_contract_details_request_job_title_id import AmendContractDetailsRequestJobTitleId
from typing import Optional, Set
from typing_extensions import Self

class AmendContractDetailsRequest(BaseModel):
    """
    You can specify any combination of data points that need changing.
    """ # noqa: E501
    scale: Optional[StrictStr] = Field(default=None, description="Defines the scale at which the amount is paid. For example, enter 'hourly' to define the amount per hour. This field can be excluded when creating a Pay-as-you-go task-based or Milestone contracts.")
    amount: Optional[Union[Annotated[float, Field(strict=True, ge=1)], Annotated[int, Field(strict=True, ge=1)]]] = Field(default=None, description="Amount to be paid per scale.")
    cycle_end: Optional[Union[Annotated[float, Field(le=31, strict=True, ge=1)], Annotated[int, Field(le=31, strict=True, ge=1)]]] = Field(default=None, description="Day of the month when the cycle ends.")
    frequency: Optional[StrictStr] = Field(default=None, description="Scale of the invoice cycle.")
    job_title_id: Optional[AmendContractDetailsRequestJobTitleId] = None
    seniority_id: Optional[AmendContractDetailsRequestJobTitleId] = None
    currency_code: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Currency code in ISO 4217 format.")
    first_payment: Optional[Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]]] = Field(default=None, description="Amount to be paid as the first payment.")
    scope_of_work: Optional[StrictStr] = Field(default=None, description="Text to describe the scope of work of the contract.")
    cycle_end_type: Optional[StrictStr] = Field(default=None, description="Cycle end can be weekly 1-7 (Monday = 1) or monthly 1-31.")
    effective_date: Optional[date] = Field(default=None, description="Short date in format ISO-8601 (YYYY-MM-DD). For example: 2022-12-31.")
    job_title_name: Optional[StrictStr] = Field(default=None, description="You can enter new job title.")
    special_clause: Optional[StrictStr] = Field(default=None, description="Text to describe any special clause in contract.")
    payment_due_days: Optional[Union[Annotated[float, Field(le=90, strict=True, ge=0)], Annotated[int, Field(le=90, strict=True, ge=0)]]] = Field(default=None, description="Number of days after the invoice is sent that the payment is due.")
    payment_due_type: Optional[StrictStr] = Field(default='REGULAR', description="Type of payment due. If the payment is due on the last day of month, enter 'WITHIN_MONTH'.")
    first_payment_date: Optional[date] = Field(default=None, description="Short date in format ISO-8601 (YYYY-MM-DD). For example: 2022-12-31.")
    pay_before_weekends: Optional[StrictBool] = Field(default=None, description="If the payment due is on a weekend, pay on Friday.")
    __properties: ClassVar[List[str]] = ["scale", "amount", "cycle_end", "frequency", "job_title_id", "seniority_id", "currency_code", "first_payment", "scope_of_work", "cycle_end_type", "effective_date", "job_title_name", "special_clause", "payment_due_days", "payment_due_type", "first_payment_date", "pay_before_weekends"]

    @field_validator('scale')
    def scale_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['hourly', 'daily', 'weekly', 'monthly', 'biweekly', 'semimonthly', 'custom']):
            raise ValueError("must be one of enum values ('hourly', 'daily', 'weekly', 'monthly', 'biweekly', 'semimonthly', 'custom')")
        return value

    @field_validator('frequency')
    def frequency_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['weekly', 'monthly', 'biweekly', 'semimonthly', 'calendar-month']):
            raise ValueError("must be one of enum values ('weekly', 'monthly', 'biweekly', 'semimonthly', 'calendar-month')")
        return value

    @field_validator('currency_code')
    def currency_code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Z]{3}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{3}$/")
        return value

    @field_validator('cycle_end_type')
    def cycle_end_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['DAY_OF_WEEK', 'DAY_OF_LAST_WEEK', 'DAY_OF_MONTH']):
            raise ValueError("must be one of enum values ('DAY_OF_WEEK', 'DAY_OF_LAST_WEEK', 'DAY_OF_MONTH')")
        return value

    @field_validator('payment_due_type')
    def payment_due_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['REGULAR', 'WITHIN_MONTH']):
            raise ValueError("must be one of enum values ('REGULAR', 'WITHIN_MONTH')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AmendContractDetailsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of job_title_id
        if self.job_title_id:
            _dict['job_title_id'] = self.job_title_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of seniority_id
        if self.seniority_id:
            _dict['seniority_id'] = self.seniority_id.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AmendContractDetailsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "scale": obj.get("scale"),
            "amount": obj.get("amount"),
            "cycle_end": obj.get("cycle_end"),
            "frequency": obj.get("frequency"),
            "job_title_id": AmendContractDetailsRequestJobTitleId.from_dict(obj["job_title_id"]) if obj.get("job_title_id") is not None else None,
            "seniority_id": AmendContractDetailsRequestJobTitleId.from_dict(obj["seniority_id"]) if obj.get("seniority_id") is not None else None,
            "currency_code": obj.get("currency_code"),
            "first_payment": obj.get("first_payment"),
            "scope_of_work": obj.get("scope_of_work"),
            "cycle_end_type": obj.get("cycle_end_type"),
            "effective_date": obj.get("effective_date"),
            "job_title_name": obj.get("job_title_name"),
            "special_clause": obj.get("special_clause"),
            "payment_due_days": obj.get("payment_due_days"),
            "payment_due_type": obj.get("payment_due_type") if obj.get("payment_due_type") is not None else 'REGULAR',
            "first_payment_date": obj.get("first_payment_date"),
            "pay_before_weekends": obj.get("pay_before_weekends")
        })
        return _obj


