# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.client_of_basic_contract import ClientOfBasicContract
from dima_sdk.models.contract_status_enum import ContractStatusEnum
from dima_sdk.models.contract_type_enum import ContractTypeEnum
from dima_sdk.models.contract_who_reports_enum import ContractWhoReportsEnum
from dima_sdk.models.invitations_of_basic_contract import InvitationsOfBasicContract
from dima_sdk.models.signatures_of_basic_contract import SignaturesOfBasicContract
from dima_sdk.models.worker_of_basic_contract import WorkerOfBasicContract
from typing import Optional, Set
from typing_extensions import Self

class BasicContract(BaseModel):
    """
    BasicContract
    """ # noqa: E501
    id: Annotated[str, Field(min_length=1, strict=True)]
    title: Annotated[str, Field(min_length=1, strict=True)]
    type: ContractTypeEnum
    status: ContractStatusEnum
    client: ClientOfBasicContract
    worker: Optional[WorkerOfBasicContract]
    invitations: InvitationsOfBasicContract
    signatures: SignaturesOfBasicContract
    is_shielded: StrictBool
    is_archived: StrictBool
    created_at: Optional[datetime] = Field(description="Long date-time format following ISO-8601")
    termination_date: Optional[datetime] = Field(description="Long date-time format following ISO-8601")
    notice_period: Optional[Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]]] = Field(default=0, description="Days before to notice the termination of contract for eather party.")
    scale: Optional[StrictStr] = Field(default=None, description="The payment scale (e.g., hourly, weekly, monthly, etc.)")
    who_reports: Optional[ContractWhoReportsEnum] = None
    external_id: Optional[StrictStr] = Field(default=None, description="A unique identifier for the object provided by an external system.")
    __properties: ClassVar[List[str]] = ["id", "title", "type", "status", "client", "worker", "invitations", "signatures", "is_shielded", "is_archived", "created_at", "termination_date", "notice_period", "scale", "who_reports", "external_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BasicContract from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of client
        if self.client:
            _dict['client'] = self.client.to_dict()
        # override the default output from pydantic by calling `to_dict()` of worker
        if self.worker:
            _dict['worker'] = self.worker.to_dict()
        # override the default output from pydantic by calling `to_dict()` of invitations
        if self.invitations:
            _dict['invitations'] = self.invitations.to_dict()
        # override the default output from pydantic by calling `to_dict()` of signatures
        if self.signatures:
            _dict['signatures'] = self.signatures.to_dict()
        # set to None if worker (nullable) is None
        # and model_fields_set contains the field
        if self.worker is None and "worker" in self.model_fields_set:
            _dict['worker'] = None

        # set to None if created_at (nullable) is None
        # and model_fields_set contains the field
        if self.created_at is None and "created_at" in self.model_fields_set:
            _dict['created_at'] = None

        # set to None if termination_date (nullable) is None
        # and model_fields_set contains the field
        if self.termination_date is None and "termination_date" in self.model_fields_set:
            _dict['termination_date'] = None

        # set to None if scale (nullable) is None
        # and model_fields_set contains the field
        if self.scale is None and "scale" in self.model_fields_set:
            _dict['scale'] = None

        # set to None if external_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_id is None and "external_id" in self.model_fields_set:
            _dict['external_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BasicContract from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "title": obj.get("title"),
            "type": obj.get("type"),
            "status": obj.get("status"),
            "client": ClientOfBasicContract.from_dict(obj["client"]) if obj.get("client") is not None else None,
            "worker": WorkerOfBasicContract.from_dict(obj["worker"]) if obj.get("worker") is not None else None,
            "invitations": InvitationsOfBasicContract.from_dict(obj["invitations"]) if obj.get("invitations") is not None else None,
            "signatures": SignaturesOfBasicContract.from_dict(obj["signatures"]) if obj.get("signatures") is not None else None,
            "is_shielded": obj.get("is_shielded"),
            "is_archived": obj.get("is_archived"),
            "created_at": obj.get("created_at"),
            "termination_date": obj.get("termination_date"),
            "notice_period": obj.get("notice_period") if obj.get("notice_period") is not None else 0,
            "scale": obj.get("scale"),
            "who_reports": obj.get("who_reports"),
            "external_id": obj.get("external_id")
        })
        return _obj


