# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.identifier_value_for_filter import IdentifierValueForFilter
from typing import Optional, Set
from typing_extensions import Self

class BgCheckForContractToCreate(BaseModel):
    """
    The background check information for a contract. Either `individual_check_ids` or `package_id` must be provided, but not both.
    """ # noqa: E501
    contract_ids: List[StrictStr] = Field(description="Please note that this field supports a single contract ID as of now. Support for multiple contract IDs will be added in near future. Please refer to changelog for updates.")
    individual_check_ids: Optional[List[IdentifierValueForFilter]] = Field(default=None, description="A list of individual check IDs.")
    package_id: Optional[IdentifierValueForFilter] = None
    __properties: ClassVar[List[str]] = ["contract_ids", "individual_check_ids", "package_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BgCheckForContractToCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in individual_check_ids (list)
        _items = []
        if self.individual_check_ids:
            for _item_individual_check_ids in self.individual_check_ids:
                if _item_individual_check_ids:
                    _items.append(_item_individual_check_ids.to_dict())
            _dict['individual_check_ids'] = _items
        # override the default output from pydantic by calling `to_dict()` of package_id
        if self.package_id:
            _dict['package_id'] = self.package_id.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BgCheckForContractToCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contract_ids": obj.get("contract_ids"),
            "individual_check_ids": [IdentifierValueForFilter.from_dict(_item) for _item in obj["individual_check_ids"]] if obj.get("individual_check_ids") is not None else None,
            "package_id": IdentifierValueForFilter.from_dict(obj["package_id"]) if obj.get("package_id") is not None else None
        })
        return _obj


