# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.calculate_eor_employment_cost_request_data_benefits_inner import CalculateEorEmploymentCostRequestDataBenefitsInner
from typing import Optional, Set
from typing_extensions import Self

class CalculateEorEmploymentCostRequestData(BaseModel):
    """
    CalculateEorEmploymentCostRequestData
    """ # noqa: E501
    state: Optional[StrictStr] = Field(default=None, description="The state or region within the country, if applicable.")
    salary: Union[Annotated[float, Field(strict=True, ge=1)], Annotated[int, Field(strict=True, ge=1)]] = Field(description="The base salary for the employee.")
    country: StrictStr = Field(description="The country where the employee is based.")
    benefits: Optional[List[CalculateEorEmploymentCostRequestDataBenefitsInner]] = Field(default=None, description="A list of selected benefit plans for the employee.")
    currency: StrictStr = Field(description="The currency in which the costs are calculated.")
    __properties: ClassVar[List[str]] = ["state", "salary", "country", "benefits", "currency"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CalculateEorEmploymentCostRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in benefits (list)
        _items = []
        if self.benefits:
            for _item_benefits in self.benefits:
                if _item_benefits:
                    _items.append(_item_benefits.to_dict())
            _dict['benefits'] = _items
        # set to None if benefits (nullable) is None
        # and model_fields_set contains the field
        if self.benefits is None and "benefits" in self.model_fields_set:
            _dict['benefits'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CalculateEorEmploymentCostRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "state": obj.get("state"),
            "salary": obj.get("salary"),
            "country": obj.get("country"),
            "benefits": [CalculateEorEmploymentCostRequestDataBenefitsInner.from_dict(_item) for _item in obj["benefits"]] if obj.get("benefits") is not None else None,
            "currency": obj.get("currency")
        })
        return _obj


