# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from dima_sdk.models.contract_to_create_ongoing_time_based import ContractToCreateOngoingTimeBased
from dima_sdk.models.contract_to_create_pay_as_you_go_time_based import ContractToCreatePayAsYouGoTimeBased
from dima_sdk.models.contract_to_create_payg_milestones import ContractToCreatePaygMilestones
from dima_sdk.models.contract_to_create_payg_tasks import ContractToCreatePaygTasks
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

CONTRACTTOCREATE_ONE_OF_SCHEMAS = ["ContractToCreateOngoingTimeBased", "ContractToCreatePayAsYouGoTimeBased", "ContractToCreatePaygMilestones", "ContractToCreatePaygTasks"]

class ContractToCreate(BaseModel):
    """
    ContractToCreate
    """
    # data type: ContractToCreatePayAsYouGoTimeBased
    oneof_schema_1_validator: Optional[ContractToCreatePayAsYouGoTimeBased] = None
    # data type: ContractToCreatePaygTasks
    oneof_schema_2_validator: Optional[ContractToCreatePaygTasks] = None
    # data type: ContractToCreatePaygMilestones
    oneof_schema_3_validator: Optional[ContractToCreatePaygMilestones] = None
    # data type: ContractToCreateOngoingTimeBased
    oneof_schema_4_validator: Optional[ContractToCreateOngoingTimeBased] = None
    actual_instance: Optional[Union[ContractToCreateOngoingTimeBased, ContractToCreatePayAsYouGoTimeBased, ContractToCreatePaygMilestones, ContractToCreatePaygTasks]] = None
    one_of_schemas: Set[str] = { "ContractToCreateOngoingTimeBased", "ContractToCreatePayAsYouGoTimeBased", "ContractToCreatePaygMilestones", "ContractToCreatePaygTasks" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ContractToCreate.model_construct()
        error_messages = []
        match = 0
        # validate data type: ContractToCreatePayAsYouGoTimeBased
        if not isinstance(v, ContractToCreatePayAsYouGoTimeBased):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ContractToCreatePayAsYouGoTimeBased`")
        else:
            match += 1
        # validate data type: ContractToCreatePaygTasks
        if not isinstance(v, ContractToCreatePaygTasks):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ContractToCreatePaygTasks`")
        else:
            match += 1
        # validate data type: ContractToCreatePaygMilestones
        if not isinstance(v, ContractToCreatePaygMilestones):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ContractToCreatePaygMilestones`")
        else:
            match += 1
        # validate data type: ContractToCreateOngoingTimeBased
        if not isinstance(v, ContractToCreateOngoingTimeBased):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ContractToCreateOngoingTimeBased`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ContractToCreate with oneOf schemas: ContractToCreateOngoingTimeBased, ContractToCreatePayAsYouGoTimeBased, ContractToCreatePaygMilestones, ContractToCreatePaygTasks. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ContractToCreate with oneOf schemas: ContractToCreateOngoingTimeBased, ContractToCreatePayAsYouGoTimeBased, ContractToCreatePaygMilestones, ContractToCreatePaygTasks. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ContractToCreatePayAsYouGoTimeBased
        try:
            instance.actual_instance = ContractToCreatePayAsYouGoTimeBased.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ContractToCreatePaygTasks
        try:
            instance.actual_instance = ContractToCreatePaygTasks.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ContractToCreatePaygMilestones
        try:
            instance.actual_instance = ContractToCreatePaygMilestones.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ContractToCreateOngoingTimeBased
        try:
            instance.actual_instance = ContractToCreateOngoingTimeBased.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ContractToCreate with oneOf schemas: ContractToCreateOngoingTimeBased, ContractToCreatePayAsYouGoTimeBased, ContractToCreatePaygMilestones, ContractToCreatePaygTasks. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ContractToCreate with oneOf schemas: ContractToCreateOngoingTimeBased, ContractToCreatePayAsYouGoTimeBased, ContractToCreatePaygMilestones, ContractToCreatePaygTasks. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ContractToCreateOngoingTimeBased, ContractToCreatePayAsYouGoTimeBased, ContractToCreatePaygMilestones, ContractToCreatePaygTasks]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


