# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CreateCaseRequestData(BaseModel):
    """
    CreateCaseRequestData
    """ # noqa: E501
    team_id: Optional[StrictStr] = Field(default=None, description="The team ID. Required for EOR visa applications. Identifies the team handling the case")
    case_type: StrictStr = Field(description="The type of immigration case to be created. Determines the workflow and requirements")
    entity_id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the entity sponsoring the visa. Required for sponsored visa applications")
    contract_id: Optional[Annotated[str, Field(strict=True, max_length=20)]] = Field(default=None, description="The contract object identifier. Required for document reviews and visa applications")
    country_code: Annotated[str, Field(strict=True, max_length=2)] = Field(description="ISO 3166-1 alpha-2 country code where the immigration case needs to be processed")
    visa_type_id: Optional[StrictStr] = Field(default=None, description="The id of visa type that is being applied for. Identifies the type of the visa.")
    __properties: ClassVar[List[str]] = ["team_id", "case_type", "entity_id", "contract_id", "country_code", "visa_type_id"]

    @field_validator('case_type')
    def case_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['RIGHT_TO_WORK', 'EOR_VISA', 'SPONSORED_VISA', 'PRE_HIRE_EOR_VISA', 'PRE_HIRE_SPONSORSHIP_VISA']):
            raise ValueError("must be one of enum values ('RIGHT_TO_WORK', 'EOR_VISA', 'SPONSORED_VISA', 'PRE_HIRE_EOR_VISA', 'PRE_HIRE_SPONSORSHIP_VISA')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCaseRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCaseRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "team_id": obj.get("team_id"),
            "case_type": obj.get("case_type"),
            "entity_id": obj.get("entity_id"),
            "contract_id": obj.get("contract_id"),
            "country_code": obj.get("country_code"),
            "visa_type_id": obj.get("visa_type_id")
        })
        return _obj


