# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CreateDirectEmployee201ResponseDataEmployee(BaseModel):
    """
    The person that is being hired
    """ # noqa: E501
    email: StrictStr = Field(description="The personal email of the person being hired")
    last_name: StrictStr = Field(description="The last name of the person being hired")
    first_name: StrictStr = Field(description="The first name of the person being hired")
    work_email: Optional[StrictStr] = Field(default=None, description="The work email of the person being hired")
    external_id: Optional[StrictStr] = Field(default=None, description="An external identifier for the person being hired")
    nationality: Annotated[str, Field(min_length=2, strict=True, max_length=2)] = Field(description="The nationality of the person being hired")
    __properties: ClassVar[List[str]] = ["email", "last_name", "first_name", "work_email", "external_id", "nationality"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateDirectEmployee201ResponseDataEmployee from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if external_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_id is None and "external_id" in self.model_fields_set:
            _dict['external_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateDirectEmployee201ResponseDataEmployee from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "email": obj.get("email"),
            "last_name": obj.get("last_name"),
            "first_name": obj.get("first_name"),
            "work_email": obj.get("work_email"),
            "external_id": obj.get("external_id"),
            "nationality": obj.get("nationality")
        })
        return _obj


