# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class CreateEorContractRequestDataCompensationDetails(BaseModel):
    """
    CreateEorContractRequestDataCompensationDetails
    """ # noqa: E501
    salary: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Employee's gross annual salary.")
    currency: StrictStr = Field(description="Salary currency.")
    variable_compensation: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Variable compensation. For example, if the person will earn 5% of the gross annual salary as the variable compensation, enter 5.")
    variable_compensation_type: Optional[StrictStr] = Field(default=None, description="Should be set only if variable_compensation is set. It can be PERCENTAGE or FIXED.")
    __properties: ClassVar[List[str]] = ["salary", "currency", "variable_compensation", "variable_compensation_type"]

    @field_validator('variable_compensation_type')
    def variable_compensation_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['PERCENTAGE', 'FIXED']):
            raise ValueError("must be one of enum values ('PERCENTAGE', 'FIXED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateEorContractRequestDataCompensationDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if variable_compensation (nullable) is None
        # and model_fields_set contains the field
        if self.variable_compensation is None and "variable_compensation" in self.model_fields_set:
            _dict['variable_compensation'] = None

        # set to None if variable_compensation_type (nullable) is None
        # and model_fields_set contains the field
        if self.variable_compensation_type is None and "variable_compensation_type" in self.model_fields_set:
            _dict['variable_compensation_type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateEorContractRequestDataCompensationDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "salary": obj.get("salary"),
            "currency": obj.get("currency"),
            "variable_compensation": obj.get("variable_compensation"),
            "variable_compensation_type": obj.get("variable_compensation_type")
        })
        return _obj


