# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from dima_sdk.models.create_legal_entity_request_data_address import CreateLegalEntityRequestDataAddress
from dima_sdk.models.create_legal_entity_request_data_company_identifiers import CreateLegalEntityRequestDataCompanyIdentifiers
from typing import Optional, Set
from typing_extensions import Self

class CreateLegalEntityRequestData(BaseModel):
    """
    CreateLegalEntityRequestData
    """ # noqa: E501
    name: StrictStr = Field(description="The legal name of the entity.")
    phone: StrictStr = Field(description="Contact phone number for the entity.")
    address: CreateLegalEntityRequestDataAddress
    sic_number: StrictStr = Field(description="The SIC number for the entity.")
    entity_type: StrictStr = Field(description="Type of the entity.")
    company_identifiers: CreateLegalEntityRequestDataCompanyIdentifiers
    __properties: ClassVar[List[str]] = ["name", "phone", "address", "sic_number", "entity_type", "company_identifiers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateLegalEntityRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of company_identifiers
        if self.company_identifiers:
            _dict['company_identifiers'] = self.company_identifiers.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateLegalEntityRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "phone": obj.get("phone"),
            "address": CreateLegalEntityRequestDataAddress.from_dict(obj["address"]) if obj.get("address") is not None else None,
            "sic_number": obj.get("sic_number"),
            "entity_type": obj.get("entity_type"),
            "company_identifiers": CreateLegalEntityRequestDataCompanyIdentifiers.from_dict(obj["company_identifiers"]) if obj.get("company_identifiers") is not None else None
        })
        return _obj


