# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from dima_sdk.models.time_tracking_shift_meta_schema import TimeTrackingShiftMetaSchema
from dima_sdk.models.time_tracking_shift_summary_schema import TimeTrackingShiftSummarySchema
from typing import Optional, Set
from typing_extensions import Self

class CreateShiftSchema(BaseModel):
    """
    Schema for a single shift
    """ # noqa: E501
    external_id: StrictStr = Field(description="External ID of the shift")
    description: Annotated[str, Field(min_length=1, strict=True, max_length=3000)] = Field(description="Description of the shift")
    date_of_work: Annotated[str, Field(strict=True)] = Field(description="Date of work in YYYY-MM-DD format")
    meta: Optional[TimeTrackingShiftMetaSchema] = None
    summary: TimeTrackingShiftSummarySchema
    __properties: ClassVar[List[str]] = ["external_id", "description", "date_of_work", "meta", "summary"]

    @field_validator('date_of_work')
    def date_of_work_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^\d{4}-\d{2}-\d{2}$", value):
            raise ValueError(r"must validate the regular expression /^\d{4}-\d{2}-\d{2}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateShiftSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of meta
        if self.meta:
            _dict['meta'] = self.meta.to_dict()
        # override the default output from pydantic by calling `to_dict()` of summary
        if self.summary:
            _dict['summary'] = self.summary.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateShiftSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "external_id": obj.get("external_id"),
            "description": obj.get("description"),
            "date_of_work": obj.get("date_of_work"),
            "meta": TimeTrackingShiftMetaSchema.from_dict(obj["meta"]) if obj.get("meta") is not None else None,
            "summary": TimeTrackingShiftSummarySchema.from_dict(obj["summary"]) if obj.get("summary") is not None else None
        })
        return _obj


