# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.create_task_many_review201_response_data_inner_attachment import CreateTaskManyReview201ResponseDataInnerAttachment
from typing import Optional, Set
from typing_extensions import Self

class CreateTaskManyReview201ResponseDataInner(BaseModel):
    """
    CreateTaskManyReview201ResponseDataInner
    """ # noqa: E501
    id: StrictStr = Field(description="The unique ID of the task.")
    amount: Union[Annotated[float, Field(strict=True, ge=1)], Annotated[int, Field(strict=True, ge=1)]] = Field(description="The amount associated with the task.")
    status: StrictStr = Field(description="The review status of the task.")
    attachment: Optional[CreateTaskManyReview201ResponseDataInnerAttachment] = None
    description: StrictStr = Field(description="A description of the task.")
    date_submitted: date = Field(description="The date the task was submitted, in ISO 8601 format.")
    __properties: ClassVar[List[str]] = ["id", "amount", "status", "attachment", "description", "date_submitted"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateTaskManyReview201ResponseDataInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of attachment
        if self.attachment:
            _dict['attachment'] = self.attachment.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateTaskManyReview201ResponseDataInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "amount": obj.get("amount"),
            "status": obj.get("status"),
            "attachment": CreateTaskManyReview201ResponseDataInnerAttachment.from_dict(obj["attachment"]) if obj.get("attachment") is not None else None,
            "description": obj.get("description"),
            "date_submitted": obj.get("date_submitted")
        })
        return _obj


