# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.create_veriff_session_request_data_user_input import CreateVeriffSessionRequestDataUserInput
from typing import Optional, Set
from typing_extensions import Self

class CreateVeriffSessionRequestData(BaseModel):
    """
    CreateVeriffSessionRequestData
    """ # noqa: E501
    user_input: Optional[CreateVeriffSessionRequestDataUserInput] = None
    operation_type: StrictStr = Field(description="The type of KYC operation to perform")
    __properties: ClassVar[List[str]] = ["user_input", "operation_type"]

    @field_validator('operation_type')
    def operation_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['IDENTITY_RESUBMISSION_KYC', 'IDENTITY_VERIFICATION_KYC', 'NAME_CHANGE_KYC', 'EMAIL_CHANGE_KYC']):
            raise ValueError("must be one of enum values ('IDENTITY_RESUBMISSION_KYC', 'IDENTITY_VERIFICATION_KYC', 'NAME_CHANGE_KYC', 'EMAIL_CHANGE_KYC')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateVeriffSessionRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of user_input
        if self.user_input:
            _dict['user_input'] = self.user_input.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateVeriffSessionRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "user_input": CreateVeriffSessionRequestDataUserInput.from_dict(obj["user_input"]) if obj.get("user_input") is not None else None,
            "operation_type": obj.get("operation_type")
        })
        return _obj


