# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.custom_fields_object_settings import CustomFieldsObjectSettings
from dima_sdk.models.custom_fields_object_type import CustomFieldsObjectType
from typing import Optional, Set
from typing_extensions import Self

class CustomFieldsObject(BaseModel):
    """
    CustomFieldsObject
    """ # noqa: E501
    id: Optional[StrictStr] = None
    name: Optional[StrictStr] = Field(default=None, description="Name of the custom field")
    type: Optional[CustomFieldsObjectType] = None
    settings: Optional[CustomFieldsObjectSettings] = None
    created_at: Optional[date] = Field(default=None, description="Creation date of the custom field", alias="createdAt")
    placement: Optional[StrictStr] = Field(default=None, description="Valid placements for custom field")
    description: Optional[StrictStr] = Field(default=None, description="Description of the custom field")
    __properties: ClassVar[List[str]] = ["id", "name", "type", "settings", "createdAt", "placement", "description"]

    @field_validator('placement')
    def placement_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['profile', 'contract']):
            raise ValueError("must be one of enum values ('profile', 'contract')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomFieldsObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of type
        if self.type:
            _dict['type'] = self.type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of settings
        if self.settings:
            _dict['settings'] = self.settings.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomFieldsObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "type": CustomFieldsObjectType.from_dict(obj["type"]) if obj.get("type") is not None else None,
            "settings": CustomFieldsObjectSettings.from_dict(obj["settings"]) if obj.get("settings") is not None else None,
            "createdAt": obj.get("createdAt"),
            "placement": obj.get("placement"),
            "description": obj.get("description")
        })
        return _obj


