# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.employee_timeoffs_item_response_attachments_inner import EmployeeTimeoffsItemResponseAttachmentsInner
from dima_sdk.models.requester_time_off import RequesterTimeOff
from typing import Optional, Set
from typing_extensions import Self

class EmployeeTimeoffsItemResponse(BaseModel):
    """
    EmployeeTimeoffsItemResponse
    """ # noqa: E501
    time_off_id: Optional[StrictStr] = None
    time_off_type_id: Optional[StrictStr] = None
    policy_id: Optional[StrictStr] = None
    policy_name: Optional[StrictStr] = None
    policy_type_name: Optional[StrictStr] = None
    reason: Optional[StrictStr] = None
    type: Optional[StrictStr] = Field(default=None, description="Time off type.")
    requested_at: Optional[StrictStr] = None
    reviewed_at: Optional[StrictStr] = None
    with_multiple_dates: Optional[StrictBool] = None
    single_date: Optional[StrictStr] = None
    created_at: Optional[StrictStr] = None
    updated_at: Optional[StrictStr] = None
    denial_reason: Optional[StrictBool] = None
    requester: Optional[RequesterTimeOff] = None
    days_used_start_year: Optional[StrictStr] = None
    days_used_end_year: Optional[StrictStr] = None
    days_used: Optional[StrictStr] = None
    start_date: Optional[StrictStr] = None
    end_date: Optional[StrictStr] = None
    is_start_date_half_day: Optional[StrictBool] = None
    is_end_date_half_day: Optional[StrictBool] = None
    attachments: Optional[List[EmployeeTimeoffsItemResponseAttachmentsInner]] = None
    change_request: Optional[StrictStr] = None
    is_updated: Optional[StrictBool] = None
    applied_changes: Optional[List[Any]] = None
    can_request_changes: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["time_off_id", "time_off_type_id", "policy_id", "policy_name", "policy_type_name", "reason", "type", "requested_at", "reviewed_at", "with_multiple_dates", "single_date", "created_at", "updated_at", "denial_reason", "requester", "days_used_start_year", "days_used_end_year", "days_used", "start_date", "end_date", "is_start_date_half_day", "is_end_date_half_day", "attachments", "change_request", "is_updated", "applied_changes", "can_request_changes"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['VACATION', 'SICK_LEAVE', 'OTHER']):
            raise ValueError("must be one of enum values ('VACATION', 'SICK_LEAVE', 'OTHER')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmployeeTimeoffsItemResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of requester
        if self.requester:
            _dict['requester'] = self.requester.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in attachments (list)
        _items = []
        if self.attachments:
            for _item_attachments in self.attachments:
                if _item_attachments:
                    _items.append(_item_attachments.to_dict())
            _dict['attachments'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmployeeTimeoffsItemResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "time_off_id": obj.get("time_off_id"),
            "time_off_type_id": obj.get("time_off_type_id"),
            "policy_id": obj.get("policy_id"),
            "policy_name": obj.get("policy_name"),
            "policy_type_name": obj.get("policy_type_name"),
            "reason": obj.get("reason"),
            "type": obj.get("type"),
            "requested_at": obj.get("requested_at"),
            "reviewed_at": obj.get("reviewed_at"),
            "with_multiple_dates": obj.get("with_multiple_dates"),
            "single_date": obj.get("single_date"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "denial_reason": obj.get("denial_reason"),
            "requester": RequesterTimeOff.from_dict(obj["requester"]) if obj.get("requester") is not None else None,
            "days_used_start_year": obj.get("days_used_start_year"),
            "days_used_end_year": obj.get("days_used_end_year"),
            "days_used": obj.get("days_used"),
            "start_date": obj.get("start_date"),
            "end_date": obj.get("end_date"),
            "is_start_date_half_day": obj.get("is_start_date_half_day"),
            "is_end_date_half_day": obj.get("is_end_date_half_day"),
            "attachments": [EmployeeTimeoffsItemResponseAttachmentsInner.from_dict(_item) for _item in obj["attachments"]] if obj.get("attachments") is not None else None,
            "change_request": obj.get("change_request"),
            "is_updated": obj.get("is_updated"),
            "applied_changes": obj.get("applied_changes"),
            "can_request_changes": obj.get("can_request_changes")
        })
        return _obj


