# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.people_client_legal_entity import PeopleClientLegalEntity
from dima_sdk.models.people_payment import PeoplePayment
from dima_sdk.models.team import Team
from typing import Optional, Set
from typing_extensions import Self

class Employment(BaseModel):
    """
    Employment
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the employment.")
    name: Optional[StrictStr] = Field(default=None, description="The name of the employment.")
    team: Optional[Team] = None
    email: Optional[StrictStr] = Field(default=None, description="The email associated with the employment.")
    state: Optional[StrictStr] = Field(default=None, description="The state associated with the employment.")
    country: Optional[StrictStr] = Field(default=None, description="The country associated with the employment.")
    payment: Optional[PeoplePayment] = None
    is_ended: Optional[StrictBool] = Field(default=None, description="Indicates whether the employment has ended.")
    timezone: Optional[StrictStr] = Field(default=None, description="The timezone associated with the employment.")
    job_title: Optional[StrictStr] = Field(default=None, description="The job title associated with the employment.")
    seniority: Optional[StrictStr] = Field(default=None, description="The seniority level associated with the employment.")
    start_date: Optional[StrictStr] = Field(default=None, description="The start date of the employment.")
    work_email: Optional[StrictStr] = Field(default=None, description="The work email associated with the employment.")
    hiring_type: Optional[StrictStr] = Field(default=None, description="The hiring type associated with the employment.")
    hiring_status: Optional[StrictStr] = Field(default=None, description="The hiring status associated with the employment.")
    completion_date: Optional[StrictStr] = Field(default=None, description="The completion date of the employment.")
    contract_status: Optional[StrictStr] = Field(default=None, description="The contract status associated with the employment.")
    voluntarily_left: Optional[StrictBool] = Field(default=None, description="Indicates whether the employment was left voluntarily.")
    client_legal_entity: Optional[PeopleClientLegalEntity] = None
    has_eor_termination: Optional[StrictBool] = Field(default=None, description="Indicates whether the employment had an EOR termination.")
    contract_is_archived: Optional[StrictBool] = Field(default=None, description="Indicates whether the employment's contract is archived.")
    __properties: ClassVar[List[str]] = ["id", "name", "team", "email", "state", "country", "payment", "is_ended", "timezone", "job_title", "seniority", "start_date", "work_email", "hiring_type", "hiring_status", "completion_date", "contract_status", "voluntarily_left", "client_legal_entity", "has_eor_termination", "contract_is_archived"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Employment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of team
        if self.team:
            _dict['team'] = self.team.to_dict()
        # override the default output from pydantic by calling `to_dict()` of payment
        if self.payment:
            _dict['payment'] = self.payment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of client_legal_entity
        if self.client_legal_entity:
            _dict['client_legal_entity'] = self.client_legal_entity.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Employment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "team": Team.from_dict(obj["team"]) if obj.get("team") is not None else None,
            "email": obj.get("email"),
            "state": obj.get("state"),
            "country": obj.get("country"),
            "payment": PeoplePayment.from_dict(obj["payment"]) if obj.get("payment") is not None else None,
            "is_ended": obj.get("is_ended"),
            "timezone": obj.get("timezone"),
            "job_title": obj.get("job_title"),
            "seniority": obj.get("seniority"),
            "start_date": obj.get("start_date"),
            "work_email": obj.get("work_email"),
            "hiring_type": obj.get("hiring_type"),
            "hiring_status": obj.get("hiring_status"),
            "completion_date": obj.get("completion_date"),
            "contract_status": obj.get("contract_status"),
            "voluntarily_left": obj.get("voluntarily_left"),
            "client_legal_entity": PeopleClientLegalEntity.from_dict(obj["client_legal_entity"]) if obj.get("client_legal_entity") is not None else None,
            "has_eor_termination": obj.get("has_eor_termination"),
            "contract_is_archived": obj.get("contract_is_archived")
        })
        return _obj


