# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from dima_sdk.models.entitlements_policy_time_off_types_inner import EntitlementsPolicyTimeOffTypesInner
from dima_sdk.models.get_policies_for_profile200_response_policies_inner_policy_type import GetPoliciesForProfile200ResponsePoliciesInnerPolicyType
from typing import Optional, Set
from typing_extensions import Self

class EntitlementsPolicy(BaseModel):
    """
    EntitlementsPolicy
    """ # noqa: E501
    id: StrictStr
    name: StrictStr
    description: Optional[StrictStr] = None
    policy_type_id: Optional[StrictStr] = None
    tracking_unit: Optional[StrictStr] = None
    tracking_unit_amount: Optional[Union[StrictFloat, StrictInt]] = None
    tracking_cadence: Optional[StrictStr] = None
    tracking_start_date: Optional[datetime] = None
    created_at: datetime
    updated_at: datetime
    leave_type: Optional[StrictStr] = None
    time_off_types: Optional[List[EntitlementsPolicyTimeOffTypesInner]] = None
    policy_type: Optional[GetPoliciesForProfile200ResponsePoliciesInnerPolicyType] = None
    __properties: ClassVar[List[str]] = ["id", "name", "description", "policy_type_id", "tracking_unit", "tracking_unit_amount", "tracking_cadence", "tracking_start_date", "created_at", "updated_at", "leave_type", "time_off_types", "policy_type"]

    @field_validator('tracking_unit')
    def tracking_unit_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['HOUR', 'BUSINESS_DAY', 'CALENDAR_DAY', 'WEEK', 'MONTH', 'YEAR']):
            raise ValueError("must be one of enum values ('HOUR', 'BUSINESS_DAY', 'CALENDAR_DAY', 'WEEK', 'MONTH', 'YEAR')")
        return value

    @field_validator('tracking_cadence')
    def tracking_cadence_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['FIXED_DAY', 'ANNIVERSARY']):
            raise ValueError("must be one of enum values ('FIXED_DAY', 'ANNIVERSARY')")
        return value

    @field_validator('leave_type')
    def leave_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['SHORT_TERM_LEAVE', 'LONG_TERM_LEAVE']):
            raise ValueError("must be one of enum values ('SHORT_TERM_LEAVE', 'LONG_TERM_LEAVE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EntitlementsPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in time_off_types (list)
        _items = []
        if self.time_off_types:
            for _item_time_off_types in self.time_off_types:
                if _item_time_off_types:
                    _items.append(_item_time_off_types.to_dict())
            _dict['time_off_types'] = _items
        # override the default output from pydantic by calling `to_dict()` of policy_type
        if self.policy_type:
            _dict['policy_type'] = self.policy_type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EntitlementsPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "policy_type_id": obj.get("policy_type_id"),
            "tracking_unit": obj.get("tracking_unit"),
            "tracking_unit_amount": obj.get("tracking_unit_amount"),
            "tracking_cadence": obj.get("tracking_cadence"),
            "tracking_start_date": obj.get("tracking_start_date"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "leave_type": obj.get("leave_type"),
            "time_off_types": [EntitlementsPolicyTimeOffTypesInner.from_dict(_item) for _item in obj["time_off_types"]] if obj.get("time_off_types") is not None else None,
            "policy_type": GetPoliciesForProfile200ResponsePoliciesInnerPolicyType.from_dict(obj["policy_type"]) if obj.get("policy_type") is not None else None
        })
        return _obj


