# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from dima_sdk.models.eor_timeoffs_item import EorTimeoffsItem
from typing import Optional, Set
from typing_extensions import Self

class EorClientTimeoffRequests(BaseModel):
    """
    EorClientTimeoffRequests
    """ # noqa: E501
    year: Optional[Union[StrictFloat, StrictInt]] = None
    days_requested: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Days off requested by employee.")
    current_approved: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Days off approved.")
    yearly_limit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total number of days off allowed per year.")
    over_annual_limit: Optional[StrictBool] = Field(default=None, description="Too many days off requested by employee.")
    yearly_requests: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total number of time off requests this year.")
    requests: List[EorTimeoffsItem] = Field(description="List of time offs.")
    __properties: ClassVar[List[str]] = ["year", "days_requested", "current_approved", "yearly_limit", "over_annual_limit", "yearly_requests", "requests"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EorClientTimeoffRequests from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in requests (list)
        _items = []
        if self.requests:
            for _item_requests in self.requests:
                if _item_requests:
                    _items.append(_item_requests.to_dict())
            _dict['requests'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EorClientTimeoffRequests from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "year": obj.get("year"),
            "days_requested": obj.get("days_requested"),
            "current_approved": obj.get("current_approved"),
            "yearly_limit": obj.get("yearly_limit"),
            "over_annual_limit": obj.get("over_annual_limit"),
            "yearly_requests": obj.get("yearly_requests"),
            "requests": [EorTimeoffsItem.from_dict(_item) for _item in obj["requests"]] if obj.get("requests") is not None else None
        })
        return _obj


