# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.eor_employee_cost_calculation_response_additional_data import EorEmployeeCostCalculationResponseAdditionalData
from dima_sdk.models.eor_employee_cost_calculation_response_benefits_data_inner import EorEmployeeCostCalculationResponseBenefitsDataInner
from dima_sdk.models.eor_employee_cost_calculation_response_costs_inner import EorEmployeeCostCalculationResponseCostsInner
from typing import Optional, Set
from typing_extensions import Self

class EorEmployeeCostCalculationResponse(BaseModel):
    """
    EorEmployeeCostCalculationResponse
    """ # noqa: E501
    salary: Optional[StrictStr] = Field(default=None, description="The gross annual salary of the employee.")
    currency: Optional[StrictStr] = Field(default=None, description="The currency of the employee salary.")
    country: Optional[StrictStr] = Field(default=None, description="The country of employment.")
    country_code: Optional[StrictStr] = Field(default=None, description="The country code for the country of employment.")
    frequency: Optional[StrictStr] = Field(default=None, description="The frequency that the salary is paid out to the employee.")
    deel_fee: Optional[StrictStr] = Field(default=None, description="The monthly Deel fee.")
    severance_accural: Optional[StrictStr] = Field(default=None, description="Monthly funds to cover future potential severance payments to the employee.")
    total_costs: Optional[StrictStr] = Field(default=None, description="Total monthly cost including salary, Deel fee, severance accrual and employer costs.")
    employer_costs: Optional[StrictStr] = Field(default=None, description="Total monthly employer costs. Does not include Deel fee, salary and severance accrual.")
    costs: Optional[List[EorEmployeeCostCalculationResponseCostsInner]] = Field(default=None, description="The various costs associated with employment in the specified country.")
    additional_data: Optional[EorEmployeeCostCalculationResponseAdditionalData] = None
    benefits_data: Optional[List[EorEmployeeCostCalculationResponseBenefitsDataInner]] = Field(default=None, description="The various benefits costs involved in the calculation, if any.")
    __properties: ClassVar[List[str]] = ["salary", "currency", "country", "country_code", "frequency", "deel_fee", "severance_accural", "total_costs", "employer_costs", "costs", "additional_data", "benefits_data"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EorEmployeeCostCalculationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in costs (list)
        _items = []
        if self.costs:
            for _item_costs in self.costs:
                if _item_costs:
                    _items.append(_item_costs.to_dict())
            _dict['costs'] = _items
        # override the default output from pydantic by calling `to_dict()` of additional_data
        if self.additional_data:
            _dict['additional_data'] = self.additional_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in benefits_data (list)
        _items = []
        if self.benefits_data:
            for _item_benefits_data in self.benefits_data:
                if _item_benefits_data:
                    _items.append(_item_benefits_data.to_dict())
            _dict['benefits_data'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EorEmployeeCostCalculationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "salary": obj.get("salary"),
            "currency": obj.get("currency"),
            "country": obj.get("country"),
            "country_code": obj.get("country_code"),
            "frequency": obj.get("frequency"),
            "deel_fee": obj.get("deel_fee"),
            "severance_accural": obj.get("severance_accural"),
            "total_costs": obj.get("total_costs"),
            "employer_costs": obj.get("employer_costs"),
            "costs": [EorEmployeeCostCalculationResponseCostsInner.from_dict(_item) for _item in obj["costs"]] if obj.get("costs") is not None else None,
            "additional_data": EorEmployeeCostCalculationResponseAdditionalData.from_dict(obj["additional_data"]) if obj.get("additional_data") is not None else None,
            "benefits_data": [EorEmployeeCostCalculationResponseBenefitsDataInner.from_dict(_item) for _item in obj["benefits_data"]] if obj.get("benefits_data") is not None else None
        })
        return _obj


