# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class GetBenefitEmployee200ResponseContractsInnerCompensationsInner(BaseModel):
    """
    Details about the compensations.
    """ # noqa: E501
    rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The rate of compensation.")
    type: Optional[StrictStr] = Field(default=None, description="The type of compensation, either MAIN or VARIABLE.")
    scale: Optional[StrictStr] = Field(default=None, description="The scale of the compensation.")
    currency: Optional[StrictStr] = Field(default=None, description="The currency of the compensation.")
    cycle_scale: Optional[StrictStr] = Field(default=None, description="The cycle scale of the compensation.")
    variable_compensation_type: Optional[StrictStr] = Field(default=None, description="The type of variable compensation, either FIXED or PERCENTAGE.")
    __properties: ClassVar[List[str]] = ["rate", "type", "scale", "currency", "cycle_scale", "variable_compensation_type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['MAIN', 'VARIABLE']):
            raise ValueError("must be one of enum values ('MAIN', 'VARIABLE')")
        return value

    @field_validator('variable_compensation_type')
    def variable_compensation_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['FIXED', 'PERCENTAGE']):
            raise ValueError("must be one of enum values ('FIXED', 'PERCENTAGE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetBenefitEmployee200ResponseContractsInnerCompensationsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if scale (nullable) is None
        # and model_fields_set contains the field
        if self.scale is None and "scale" in self.model_fields_set:
            _dict['scale'] = None

        # set to None if cycle_scale (nullable) is None
        # and model_fields_set contains the field
        if self.cycle_scale is None and "cycle_scale" in self.model_fields_set:
            _dict['cycle_scale'] = None

        # set to None if variable_compensation_type (nullable) is None
        # and model_fields_set contains the field
        if self.variable_compensation_type is None and "variable_compensation_type" in self.model_fields_set:
            _dict['variable_compensation_type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetBenefitEmployee200ResponseContractsInnerCompensationsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rate": obj.get("rate"),
            "type": obj.get("type"),
            "scale": obj.get("scale"),
            "currency": obj.get("currency"),
            "cycle_scale": obj.get("cycle_scale"),
            "variable_compensation_type": obj.get("variable_compensation_type")
        })
        return _obj


