# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from dima_sdk.models.get_contract_list200_response_data_inner_worker_alternate_email_inner import GetContractList200ResponseDataInnerWorkerAlternateEmailInner
from typing import Optional, Set
from typing_extensions import Self

class GetContractList200ResponseDataInnerWorker(BaseModel):
    """
    GetContractList200ResponseDataInnerWorker
    """ # noqa: E501
    id: StrictStr = Field(description="Unique identifier of this resource.")
    email: Optional[Annotated[str, Field(min_length=5, strict=True)]] = Field(description="User's email address.")
    image: Optional[Annotated[str, Field(min_length=5, strict=True)]] = Field(default=None, description="URL of the worker's profile image.")
    full_name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Full name of the worker.")
    alternate_email: Optional[List[GetContractList200ResponseDataInnerWorkerAlternateEmailInner]] = Field(default=None, description="List of alternate email addresses.")
    __properties: ClassVar[List[str]] = ["id", "email", "image", "full_name", "alternate_email"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetContractList200ResponseDataInnerWorker from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in alternate_email (list)
        _items = []
        if self.alternate_email:
            for _item_alternate_email in self.alternate_email:
                if _item_alternate_email:
                    _items.append(_item_alternate_email.to_dict())
            _dict['alternate_email'] = _items
        # set to None if email (nullable) is None
        # and model_fields_set contains the field
        if self.email is None and "email" in self.model_fields_set:
            _dict['email'] = None

        # set to None if image (nullable) is None
        # and model_fields_set contains the field
        if self.image is None and "image" in self.model_fields_set:
            _dict['image'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetContractList200ResponseDataInnerWorker from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "email": obj.get("email"),
            "image": obj.get("image"),
            "full_name": obj.get("full_name"),
            "alternate_email": [GetContractList200ResponseDataInnerWorkerAlternateEmailInner.from_dict(_item) for _item in obj["alternate_email"]] if obj.get("alternate_email") is not None else None
        })
        return _obj


