# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.get_custom_fields_from_contracts200_response_data_settings_access import GetCustomFieldsFromContracts200ResponseDataSettingsAccess
from typing import Optional, Set
from typing_extensions import Self

class GetCustomFieldsFromContracts200ResponseDataSettings(BaseModel):
    """
    GetCustomFieldsFromContracts200ResponseDataSettings
    """ # noqa: E501
    access: Optional[GetCustomFieldsFromContracts200ResponseDataSettingsAccess] = None
    required: Optional[StrictBool] = Field(default=None, description="Whether the custom field is required")
    countries: Optional[List[StrictStr]] = Field(default=None, description="Countries for which the custom field is applicable.")
    is_enabled: Optional[StrictBool] = Field(default=None, description="Whether the custom field is enabled")
    worker_types: Optional[List[StrictStr]] = Field(default=None, description="Worker types for which the custom field is applicable")
    __properties: ClassVar[List[str]] = ["access", "required", "countries", "is_enabled", "worker_types"]

    @field_validator('worker_types')
    def worker_types_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(['eor', 'contractor', 'hris_direct_employee', 'direct_employee']):
                raise ValueError("each list item must be one of ('eor', 'contractor', 'hris_direct_employee', 'direct_employee')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCustomFieldsFromContracts200ResponseDataSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of access
        if self.access:
            _dict['access'] = self.access.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCustomFieldsFromContracts200ResponseDataSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access": GetCustomFieldsFromContracts200ResponseDataSettingsAccess.from_dict(obj["access"]) if obj.get("access") is not None else None,
            "required": obj.get("required"),
            "countries": obj.get("countries"),
            "is_enabled": obj.get("is_enabled"),
            "worker_types": obj.get("worker_types")
        })
        return _obj


