# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from dima_sdk.models.get_eor_contract_benefits200_response_data_inner_enrollment_details import GetEORContractBenefits200ResponseDataInnerEnrollmentDetails
from dima_sdk.models.get_eor_contract_benefits200_response_data_inner_plan import GetEORContractBenefits200ResponseDataInnerPlan
from dima_sdk.models.get_eor_contract_benefits200_response_data_inner_provider import GetEORContractBenefits200ResponseDataInnerProvider
from typing import Optional, Set
from typing_extensions import Self

class GetEORContractBenefits200ResponseDataInner(BaseModel):
    """
    GetEORContractBenefits200ResponseDataInner
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The unique ID of the benefit.")
    name: Optional[StrictStr] = Field(default=None, description="The name of the benefit.")
    plan: Optional[GetEORContractBenefits200ResponseDataInnerPlan] = None
    provider: Optional[GetEORContractBenefits200ResponseDataInnerProvider] = None
    offer_status: Optional[StrictStr] = Field(default=None, description="Indicates whether the benefit is offered.")
    enrollment_details: Optional[GetEORContractBenefits200ResponseDataInnerEnrollmentDetails] = None
    __properties: ClassVar[List[str]] = ["id", "name", "plan", "provider", "offer_status", "enrollment_details"]

    @field_validator('offer_status')
    def offer_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Offered', 'Not offered']):
            raise ValueError("must be one of enum values ('Offered', 'Not offered')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetEORContractBenefits200ResponseDataInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of plan
        if self.plan:
            _dict['plan'] = self.plan.to_dict()
        # override the default output from pydantic by calling `to_dict()` of provider
        if self.provider:
            _dict['provider'] = self.provider.to_dict()
        # override the default output from pydantic by calling `to_dict()` of enrollment_details
        if self.enrollment_details:
            _dict['enrollment_details'] = self.enrollment_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetEORContractBenefits200ResponseDataInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "plan": GetEORContractBenefits200ResponseDataInnerPlan.from_dict(obj["plan"]) if obj.get("plan") is not None else None,
            "provider": GetEORContractBenefits200ResponseDataInnerProvider.from_dict(obj["provider"]) if obj.get("provider") is not None else None,
            "offer_status": obj.get("offer_status"),
            "enrollment_details": GetEORContractBenefits200ResponseDataInnerEnrollmentDetails.from_dict(obj["enrollment_details"]) if obj.get("enrollment_details") is not None else None
        })
        return _obj


