# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.add_contract_document201_response_data import AddContractDocument201ResponseData
from dima_sdk.models.get_invoice_adjustments_by_contract_id200_response_data_inner_payment_cycle import GetInvoiceAdjustmentsByContractId200ResponseDataInnerPaymentCycle
from dima_sdk.models.get_invoice_adjustments_by_contract_id200_response_data_inner_reviewed_by import GetInvoiceAdjustmentsByContractId200ResponseDataInnerReviewedBy
from dima_sdk.models.get_timesheet_by_id200_response_data_all_of_reported_by import GetTimesheetById200ResponseDataAllOfReportedBy
from dima_sdk.models.get_timesheets_by_contract200_response_data_inner_contract import GetTimesheetsByContract200ResponseDataInnerContract
from dima_sdk.models.get_timesheets_by_contract200_response_data_inner_worksheet import GetTimesheetsByContract200ResponseDataInnerWorksheet
from typing import Optional, Set
from typing_extensions import Self

class GetInvoiceAdjustmentsByContractId200ResponseDataInner(BaseModel):
    """
    GetInvoiceAdjustmentsByContractId200ResponseDataInner
    """ # noqa: E501
    id: Optional[StrictStr] = Field(description="Unique identifier of this resource.")
    type: StrictStr = Field(description="Type of invoice adjustment.")
    scale: Optional[StrictStr] = None
    status: Optional[StrictStr] = Field(description="status of invoice adjustment")
    contract: GetTimesheetsByContract200ResponseDataInnerContract
    quantity: Optional[Union[StrictFloat, StrictInt]]
    worksheet: Optional[GetTimesheetsByContract200ResponseDataInnerWorksheet]
    attachment: Optional[AddContractDocument201ResponseData]
    created_at: datetime = Field(description="Long date-time format following ISO-8601")
    invoice_id: Optional[Union[StrictFloat, StrictInt]] = None
    description: StrictStr
    reported_by: GetTimesheetById200ResponseDataAllOfReportedBy
    reviewed_by: Optional[GetInvoiceAdjustmentsByContractId200ResponseDataInnerReviewedBy]
    custom_scale: Optional[StrictStr] = None
    total_amount: StrictStr
    currency_code: Annotated[str, Field(min_length=3, strict=True, max_length=3)]
    payment_cycle: GetInvoiceAdjustmentsByContractId200ResponseDataInnerPaymentCycle
    date_submitted: datetime = Field(description="Long date-time format following ISO-8601")
    __properties: ClassVar[List[str]] = ["id", "type", "scale", "status", "contract", "quantity", "worksheet", "attachment", "created_at", "invoice_id", "description", "reported_by", "reviewed_by", "custom_scale", "total_amount", "currency_code", "payment_cycle", "date_submitted"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['accrued_holiday', 'additional_fee', 'allowance', 'bonus', 'commission', 'deduction', 'deposit', 'deposit_refund', 'employer_cost', 'expense', 'health_allowance', 'health_benefit', 'health_insurance_fee', 'legal_fee', 'management_fee', 'milestone', 'offcycle', 'other', 'overtime', 'pension', 'pro_rata', 'setup_fee', 'severance', 'shield_service', 'signing_bonus', 'signing_bonus_employer_cost', 'refund', 'task', 'time_off', 'vat', 'withholding_tax', 'work']):
            raise ValueError("must be one of enum values ('accrued_holiday', 'additional_fee', 'allowance', 'bonus', 'commission', 'deduction', 'deposit', 'deposit_refund', 'employer_cost', 'expense', 'health_allowance', 'health_benefit', 'health_insurance_fee', 'legal_fee', 'management_fee', 'milestone', 'offcycle', 'other', 'overtime', 'pension', 'pro_rata', 'setup_fee', 'severance', 'shield_service', 'signing_bonus', 'signing_bonus_employer_cost', 'refund', 'task', 'time_off', 'vat', 'withholding_tax', 'work')")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['approved', 'declined', 'not_payable', 'paid', 'pending', 'processing']):
            raise ValueError("must be one of enum values ('approved', 'declined', 'not_payable', 'paid', 'pending', 'processing')")
        return value

    @field_validator('currency_code')
    def currency_code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[A-Z]{3}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{3}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetInvoiceAdjustmentsByContractId200ResponseDataInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of contract
        if self.contract:
            _dict['contract'] = self.contract.to_dict()
        # override the default output from pydantic by calling `to_dict()` of worksheet
        if self.worksheet:
            _dict['worksheet'] = self.worksheet.to_dict()
        # override the default output from pydantic by calling `to_dict()` of attachment
        if self.attachment:
            _dict['attachment'] = self.attachment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of reported_by
        if self.reported_by:
            _dict['reported_by'] = self.reported_by.to_dict()
        # override the default output from pydantic by calling `to_dict()` of reviewed_by
        if self.reviewed_by:
            _dict['reviewed_by'] = self.reviewed_by.to_dict()
        # override the default output from pydantic by calling `to_dict()` of payment_cycle
        if self.payment_cycle:
            _dict['payment_cycle'] = self.payment_cycle.to_dict()
        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if scale (nullable) is None
        # and model_fields_set contains the field
        if self.scale is None and "scale" in self.model_fields_set:
            _dict['scale'] = None

        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        # set to None if quantity (nullable) is None
        # and model_fields_set contains the field
        if self.quantity is None and "quantity" in self.model_fields_set:
            _dict['quantity'] = None

        # set to None if worksheet (nullable) is None
        # and model_fields_set contains the field
        if self.worksheet is None and "worksheet" in self.model_fields_set:
            _dict['worksheet'] = None

        # set to None if attachment (nullable) is None
        # and model_fields_set contains the field
        if self.attachment is None and "attachment" in self.model_fields_set:
            _dict['attachment'] = None

        # set to None if invoice_id (nullable) is None
        # and model_fields_set contains the field
        if self.invoice_id is None and "invoice_id" in self.model_fields_set:
            _dict['invoice_id'] = None

        # set to None if reviewed_by (nullable) is None
        # and model_fields_set contains the field
        if self.reviewed_by is None and "reviewed_by" in self.model_fields_set:
            _dict['reviewed_by'] = None

        # set to None if custom_scale (nullable) is None
        # and model_fields_set contains the field
        if self.custom_scale is None and "custom_scale" in self.model_fields_set:
            _dict['custom_scale'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetInvoiceAdjustmentsByContractId200ResponseDataInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "scale": obj.get("scale"),
            "status": obj.get("status"),
            "contract": GetTimesheetsByContract200ResponseDataInnerContract.from_dict(obj["contract"]) if obj.get("contract") is not None else None,
            "quantity": obj.get("quantity"),
            "worksheet": GetTimesheetsByContract200ResponseDataInnerWorksheet.from_dict(obj["worksheet"]) if obj.get("worksheet") is not None else None,
            "attachment": AddContractDocument201ResponseData.from_dict(obj["attachment"]) if obj.get("attachment") is not None else None,
            "created_at": obj.get("created_at"),
            "invoice_id": obj.get("invoice_id"),
            "description": obj.get("description"),
            "reported_by": GetTimesheetById200ResponseDataAllOfReportedBy.from_dict(obj["reported_by"]) if obj.get("reported_by") is not None else None,
            "reviewed_by": GetInvoiceAdjustmentsByContractId200ResponseDataInnerReviewedBy.from_dict(obj["reviewed_by"]) if obj.get("reviewed_by") is not None else None,
            "custom_scale": obj.get("custom_scale"),
            "total_amount": obj.get("total_amount"),
            "currency_code": obj.get("currency_code"),
            "payment_cycle": GetInvoiceAdjustmentsByContractId200ResponseDataInnerPaymentCycle.from_dict(obj["payment_cycle"]) if obj.get("payment_cycle") is not None else None,
            "date_submitted": obj.get("date_submitted")
        })
        return _obj


