# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetLegalEntityList200ResponseDataInner(BaseModel):
    """
    GetLegalEntityList200ResponseDataInner
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Id of the legal entity")
    name: Optional[StrictStr] = Field(default=None, description="Name of the legal entity")
    vat_id: Optional[StrictStr] = Field(default=None, description="VAT ID")
    country: Optional[StrictStr] = Field(default=None, description="Country of the legal entity")
    entity_type: Optional[StrictStr] = Field(default=None, description="Entity type")
    entity_subtype: Optional[StrictStr] = Field(default=None, description="Entity sub type")
    registration_number: Optional[StrictStr] = Field(default=None, description="Registration number", alias="registrationNumber")
    __properties: ClassVar[List[str]] = ["id", "name", "vat_id", "country", "entity_type", "entity_subtype", "registrationNumber"]

    @field_validator('entity_type')
    def entity_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['individual', 'company']):
            raise ValueError("must be one of enum values ('individual', 'company')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetLegalEntityList200ResponseDataInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if vat_id (nullable) is None
        # and model_fields_set contains the field
        if self.vat_id is None and "vat_id" in self.model_fields_set:
            _dict['vat_id'] = None

        # set to None if registration_number (nullable) is None
        # and model_fields_set contains the field
        if self.registration_number is None and "registration_number" in self.model_fields_set:
            _dict['registrationNumber'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetLegalEntityList200ResponseDataInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "vat_id": obj.get("vat_id"),
            "country": obj.get("country"),
            "entity_type": obj.get("entity_type"),
            "entity_subtype": obj.get("entity_subtype"),
            "registrationNumber": obj.get("registrationNumber")
        })
        return _obj


