# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class GetLegalEntityPayrollSettings200ResponseInner(BaseModel):
    """
    GetLegalEntityPayrollSettings200ResponseInner
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the legal entity.")
    cycle_type: Optional[StrictStr] = Field(default=None, description="Defines the payroll cycle type.")
    first_payroll_start_date: Optional[date] = Field(default=None, description="The start date of the first payroll.")
    payroll_processing_lead_time_days: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, description="The number of days required to process payroll.")
    __properties: ClassVar[List[str]] = ["id", "cycle_type", "first_payroll_start_date", "payroll_processing_lead_time_days"]

    @field_validator('cycle_type')
    def cycle_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['WEEKLY', 'BIWEEKLY', 'BIMONTHLY', 'MONTHLY']):
            raise ValueError("must be one of enum values ('WEEKLY', 'BIWEEKLY', 'BIMONTHLY', 'MONTHLY')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetLegalEntityPayrollSettings200ResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetLegalEntityPayrollSettings200ResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "cycle_type": obj.get("cycle_type"),
            "first_payroll_start_date": obj.get("first_payroll_start_date"),
            "payroll_processing_lead_time_days": obj.get("payroll_processing_lead_time_days")
        })
        return _obj


