# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class GetOrganizationRoles200ResponseInner(BaseModel):
    """
    GetOrganizationRoles200ResponseInner
    """ # noqa: E501
    id: Union[StrictFloat, StrictInt] = Field(description="The unique identifier for the role.")
    name: StrictStr = Field(description="The name of the role.")
    scope: StrictStr = Field(description="The scope of the role, which can define the level of access. For example, 'ORGANIZATION' represents a global role within the organization.")
    hris_org_structure_id: Optional[StrictStr] = Field(default=None, description="The HRIS (Human Resource Information System) organization structure ID associated with the role, if applicable.", alias="hrisOrgStructureId")
    __properties: ClassVar[List[str]] = ["id", "name", "scope", "hrisOrgStructureId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetOrganizationRoles200ResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if hris_org_structure_id (nullable) is None
        # and model_fields_set contains the field
        if self.hris_org_structure_id is None and "hris_org_structure_id" in self.model_fields_set:
            _dict['hrisOrgStructureId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetOrganizationRoles200ResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "scope": obj.get("scope"),
            "hrisOrgStructureId": obj.get("hrisOrgStructureId")
        })
        return _obj


