# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.get_payment_list200_response_data_rows_inner_payment_method import GetPaymentList200ResponseDataRowsInnerPaymentMethod
from dima_sdk.models.the_worker_for_the_payment import TheWorkerForThePayment
from typing import Optional, Set
from typing_extensions import Self

class GetPaymentList200ResponseDataRowsInner(BaseModel):
    """
    GetPaymentList200ResponseDataRowsInner
    """ # noqa: E501
    id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Unique identifier of the payment.")
    label: Optional[StrictStr] = Field(default=None, description="A descriptive label for the payment.")
    status: Optional[StrictStr] = Field(default=None, description="Status of the payment. Either 'paid' or 'processing'.")
    paid_at: Optional[datetime] = Field(default=None, description="Date and time when the payment was completed, in ISO-8601 format.")
    workers: Optional[List[TheWorkerForThePayment]] = None
    created_at: Optional[StrictStr] = Field(default=None, description="Date and time when the payment was created, in ISO-8601 format.")
    payment_method: Optional[GetPaymentList200ResponseDataRowsInnerPaymentMethod] = None
    payment_currency: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Three-letter currency code for the payment, following ISO 4217.")
    __properties: ClassVar[List[str]] = ["id", "label", "status", "paid_at", "workers", "created_at", "payment_method", "payment_currency"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['paid', 'processing']):
            raise ValueError("must be one of enum values ('paid', 'processing')")
        return value

    @field_validator('payment_currency')
    def payment_currency_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Z]{3}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{3}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPaymentList200ResponseDataRowsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in workers (list)
        _items = []
        if self.workers:
            for _item_workers in self.workers:
                if _item_workers:
                    _items.append(_item_workers.to_dict())
            _dict['workers'] = _items
        # override the default output from pydantic by calling `to_dict()` of payment_method
        if self.payment_method:
            _dict['payment_method'] = self.payment_method.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPaymentList200ResponseDataRowsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "label": obj.get("label"),
            "status": obj.get("status"),
            "paid_at": obj.get("paid_at"),
            "workers": [TheWorkerForThePayment.from_dict(_item) for _item in obj["workers"]] if obj.get("workers") is not None else None,
            "created_at": obj.get("created_at"),
            "payment_method": GetPaymentList200ResponseDataRowsInnerPaymentMethod.from_dict(obj["payment_method"]) if obj.get("payment_method") is not None else None,
            "payment_currency": obj.get("payment_currency")
        })
        return _obj


