# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetPaymentsBreakDownById200ResponseDataInner(BaseModel):
    """
    GetPaymentsBreakDownById200ResponseDataInner
    """ # noqa: E501
    var_date: Optional[StrictStr] = Field(default=None, description="The date associated with the payment breakdown.", alias="date")
    team: Optional[StrictStr] = Field(default=None, description="The name of the team or company associated with the payment.")
    work: Optional[StrictStr] = Field(default=None, description="Amount associated with work payment.")
    bonus: Optional[StrictStr] = Field(default=None, description="Bonus payment amount.")
    total: Optional[StrictStr] = Field(default=None, description="Total payment due for this breakdown item.")
    others: Optional[StrictStr] = Field(default=None, description="Other payment amounts.")
    currency: Optional[StrictStr] = Field(default=None, description="Currency code used for this payment.")
    expenses: Optional[StrictStr] = Field(default=None, description="Expenses related to the payment.")
    overtime: Optional[StrictStr] = Field(default=None, description="Overtime payment amount.")
    pro_rata: Optional[StrictStr] = Field(default=None, description="Pro-rated payment amount.")
    approvers: Optional[StrictStr] = Field(default=None, description="Approvers of the payment breakdown.")
    frequency: Optional[StrictStr] = Field(default=None, description="Frequency of payment (e.g., monthly, weekly).")
    adjustment: Optional[StrictStr] = Field(default=None, description="Adjustment amount for the payment.")
    deductions: Optional[StrictStr] = Field(default=None, description="Deductions from the payment.")
    commissions: Optional[StrictStr] = Field(default=None, description="Commissions included in the payment.")
    approve_date: Optional[StrictStr] = Field(default=None, description="The date when the payment was approved.")
    payment_date: Optional[StrictStr] = Field(default=None, description="The date the payment was made.")
    invoice_number: Optional[StrictStr] = Field(default=None, description="Invoice number associated with the payment.")
    processing_fee: Optional[StrictStr] = Field(default=None, description="Processing fee applied to the payment.")
    receipt_number: Optional[StrictStr] = Field(default=None, description="Receipt number for the payment.")
    contract_country: Optional[StrictStr] = Field(default=None, description="Country where the contract is associated.")
    contractor_email: Optional[StrictStr] = Field(default=None, description="Worker's email address.")
    payment_currency: Optional[StrictStr] = Field(default=None, description="Currency in which the payment was made.")
    contract_start_date: Optional[StrictStr] = Field(default=None, description="Start date of the contract.")
    general_ledger_account: Optional[StrictStr] = Field(default=None, description="General ledger account for the payment.")
    total_payment_currency: Optional[StrictStr] = Field(default=None, description="Total payment in the payment currency.")
    contractor_employee_name: Optional[StrictStr] = Field(default=None, description="Worker's name.")
    contractor_unique_identifier: Optional[StrictStr] = Field(default=None, description="Worker's unique identifier as a UUID.")
    __properties: ClassVar[List[str]] = ["date", "team", "work", "bonus", "total", "others", "currency", "expenses", "overtime", "pro_rata", "approvers", "frequency", "adjustment", "deductions", "commissions", "approve_date", "payment_date", "invoice_number", "processing_fee", "receipt_number", "contract_country", "contractor_email", "payment_currency", "contract_start_date", "general_ledger_account", "total_payment_currency", "contractor_employee_name", "contractor_unique_identifier"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPaymentsBreakDownById200ResponseDataInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPaymentsBreakDownById200ResponseDataInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "date": obj.get("date"),
            "team": obj.get("team"),
            "work": obj.get("work"),
            "bonus": obj.get("bonus"),
            "total": obj.get("total"),
            "others": obj.get("others"),
            "currency": obj.get("currency"),
            "expenses": obj.get("expenses"),
            "overtime": obj.get("overtime"),
            "pro_rata": obj.get("pro_rata"),
            "approvers": obj.get("approvers"),
            "frequency": obj.get("frequency"),
            "adjustment": obj.get("adjustment"),
            "deductions": obj.get("deductions"),
            "commissions": obj.get("commissions"),
            "approve_date": obj.get("approve_date"),
            "payment_date": obj.get("payment_date"),
            "invoice_number": obj.get("invoice_number"),
            "processing_fee": obj.get("processing_fee"),
            "receipt_number": obj.get("receipt_number"),
            "contract_country": obj.get("contract_country"),
            "contractor_email": obj.get("contractor_email"),
            "payment_currency": obj.get("payment_currency"),
            "contract_start_date": obj.get("contract_start_date"),
            "general_ledger_account": obj.get("general_ledger_account"),
            "total_payment_currency": obj.get("total_payment_currency"),
            "contractor_employee_name": obj.get("contractor_employee_name"),
            "contractor_unique_identifier": obj.get("contractor_unique_identifier")
        })
        return _obj


