# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class GetPeoplePersonalInformationById200ResponseDataAddressesInner(BaseModel):
    """
    GetPeoplePersonalInformationById200ResponseDataAddressesInner
    """ # noqa: E501
    id: StrictStr = Field(description="Unique identifier for the address.")
    zip: Annotated[str, Field(strict=True, max_length=255)] = Field(description="The zip code.")
    city: Annotated[str, Field(strict=True, max_length=255)] = Field(description="The city.")
    type: StrictStr = Field(description="The type of the address.")
    state: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(description="The state.")
    street: Annotated[str, Field(strict=True, max_length=255)] = Field(description="The street address.")
    country: Annotated[str, Field(strict=True, max_length=255)] = Field(description="The country.")
    __properties: ClassVar[List[str]] = ["id", "zip", "city", "type", "state", "street", "country"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['HOME', 'POSTAL']):
            raise ValueError("must be one of enum values ('HOME', 'POSTAL')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPeoplePersonalInformationById200ResponseDataAddressesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if state (nullable) is None
        # and model_fields_set contains the field
        if self.state is None and "state" in self.model_fields_set:
            _dict['state'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPeoplePersonalInformationById200ResponseDataAddressesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "zip": obj.get("zip"),
            "city": obj.get("city"),
            "type": obj.get("type"),
            "state": obj.get("state"),
            "street": obj.get("street"),
            "country": obj.get("country")
        })
        return _obj


