# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class GetTimeOffsQuery200ResponseDataInnerTimeOffDailiesInner(BaseModel):
    """
    GetTimeOffsQuery200ResponseDataInnerTimeOffDailiesInner
    """ # noqa: E501
    id: StrictStr = Field(description="Time off daily id")
    var_date: datetime = Field(description="Time off daily date", alias="date")
    type: StrictStr = Field(description="Time off daily type")
    amount: Union[StrictFloat, StrictInt] = Field(description="Time off daily amount")
    created_at: datetime = Field(description="Time off daily creation date")
    updated_at: datetime = Field(description="Time off daily update date")
    description: Optional[StrictStr] = Field(default=None, description="Time off daily description")
    time_off_id: StrictStr = Field(description="Time off id")
    __properties: ClassVar[List[str]] = ["id", "date", "type", "amount", "created_at", "updated_at", "description", "time_off_id"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['WORKING_DAY', 'NON_WORKING_DAY', 'HOLIDAY']):
            raise ValueError("must be one of enum values ('WORKING_DAY', 'NON_WORKING_DAY', 'HOLIDAY')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetTimeOffsQuery200ResponseDataInnerTimeOffDailiesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetTimeOffsQuery200ResponseDataInnerTimeOffDailiesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "date": obj.get("date"),
            "type": obj.get("type"),
            "amount": obj.get("amount"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "description": obj.get("description"),
            "time_off_id": obj.get("time_off_id")
        })
        return _obj


