# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from dima_sdk.models.invoice_status_enum import InvoiceStatusEnum
from typing import Optional, Set
from typing_extensions import Self

class Invoice(BaseModel):
    """
    Invoice
    """ # noqa: E501
    id: StrictStr = Field(description="Unique identifier of the invoice.")
    status: InvoiceStatusEnum
    currency: Annotated[str, Field(min_length=3, strict=True, max_length=3)] = Field(description="Currency code.")
    created_at: Optional[datetime] = Field(description="Long date-time format following ISO-8601")
    total: StrictStr = Field(description="Total invoice amount including Fee and VAT.")
    amount: StrictStr = Field(description="Billed amount.")
    deel_fee: StrictStr = Field(description="Deel fee.")
    label: StrictStr = Field(description="Label of the invoice.")
    paid_at: Optional[datetime] = Field(description="Long date-time format following ISO-8601")
    vat_total: Optional[StrictStr] = Field(description="Amount of VAT.")
    vat_percentage: Optional[StrictStr] = Field(description="VAT percentage.")
    is_overdue: Optional[StrictBool] = Field(description="Indicates if the invoice is overdue.")
    issued_at: Optional[datetime] = Field(description="Long date-time format following ISO-8601")
    vat_id: Optional[StrictStr] = Field(description="VAT identification number.")
    due_date: Optional[datetime] = Field(description="Long date-time format following ISO-8601")
    contract_id: StrictStr = Field(description="Unique identifier of the contract")
    __properties: ClassVar[List[str]] = ["id", "status", "currency", "created_at", "total", "amount", "deel_fee", "label", "paid_at", "vat_total", "vat_percentage", "is_overdue", "issued_at", "vat_id", "due_date", "contract_id"]

    @field_validator('currency')
    def currency_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[A-Z]{3}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{3}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Invoice from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if created_at (nullable) is None
        # and model_fields_set contains the field
        if self.created_at is None and "created_at" in self.model_fields_set:
            _dict['created_at'] = None

        # set to None if paid_at (nullable) is None
        # and model_fields_set contains the field
        if self.paid_at is None and "paid_at" in self.model_fields_set:
            _dict['paid_at'] = None

        # set to None if vat_total (nullable) is None
        # and model_fields_set contains the field
        if self.vat_total is None and "vat_total" in self.model_fields_set:
            _dict['vat_total'] = None

        # set to None if vat_percentage (nullable) is None
        # and model_fields_set contains the field
        if self.vat_percentage is None and "vat_percentage" in self.model_fields_set:
            _dict['vat_percentage'] = None

        # set to None if is_overdue (nullable) is None
        # and model_fields_set contains the field
        if self.is_overdue is None and "is_overdue" in self.model_fields_set:
            _dict['is_overdue'] = None

        # set to None if issued_at (nullable) is None
        # and model_fields_set contains the field
        if self.issued_at is None and "issued_at" in self.model_fields_set:
            _dict['issued_at'] = None

        # set to None if vat_id (nullable) is None
        # and model_fields_set contains the field
        if self.vat_id is None and "vat_id" in self.model_fields_set:
            _dict['vat_id'] = None

        # set to None if due_date (nullable) is None
        # and model_fields_set contains the field
        if self.due_date is None and "due_date" in self.model_fields_set:
            _dict['due_date'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Invoice from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "status": obj.get("status"),
            "currency": obj.get("currency"),
            "created_at": obj.get("created_at"),
            "total": obj.get("total"),
            "amount": obj.get("amount"),
            "deel_fee": obj.get("deel_fee"),
            "label": obj.get("label"),
            "paid_at": obj.get("paid_at"),
            "vat_total": obj.get("vat_total"),
            "vat_percentage": obj.get("vat_percentage"),
            "is_overdue": obj.get("is_overdue"),
            "issued_at": obj.get("issued_at"),
            "vat_id": obj.get("vat_id"),
            "due_date": obj.get("due_date"),
            "contract_id": obj.get("contract_id")
        })
        return _obj


