# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBytes, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated
from dima_sdk.models.invoice_adjustment_type_to_create_enum import InvoiceAdjustmentTypeToCreateEnum
from typing import Optional, Set
from typing_extensions import Self

class InvoiceAdjustmentToCreateWithFile(BaseModel):
    """
    InvoiceAdjustmentToCreateWithFile
    """ # noqa: E501
    contract_id: StrictStr = Field(description="Id of a Deel contract.")
    date_submitted: date = Field(description="Short date in format ISO-8601 (YYYY-MM-DD). For example: 2022-12-31.")
    type: InvoiceAdjustmentTypeToCreateEnum
    amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Amount to be paid. Must be a positive number.")
    description: Annotated[str, Field(strict=True, max_length=30000)] = Field(description="Description of the adjustment.")
    payment_cycle_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="ID of an existing active payment cycle - required if type is \"vat\"", alias="paymentCycleId")
    file: Optional[Union[StrictBytes, StrictStr, Tuple[StrictStr, StrictBytes]]] = Field(default=None, description="Upload the file you want to attach to this entry.")
    __properties: ClassVar[List[str]] = ["contract_id", "date_submitted", "type", "amount", "description", "paymentCycleId", "file"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InvoiceAdjustmentToCreateWithFile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if payment_cycle_id (nullable) is None
        # and model_fields_set contains the field
        if self.payment_cycle_id is None and "payment_cycle_id" in self.model_fields_set:
            _dict['paymentCycleId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InvoiceAdjustmentToCreateWithFile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contract_id": obj.get("contract_id"),
            "date_submitted": obj.get("date_submitted"),
            "type": obj.get("type"),
            "amount": obj.get("amount"),
            "description": obj.get("description"),
            "paymentCycleId": obj.get("paymentCycleId"),
            "file": obj.get("file")
        })
        return _obj


