# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class LetterRequest(BaseModel):
    """
    LetterRequest
    """ # noqa: E501
    description: Annotated[str, Field(min_length=25, strict=True)] = Field(description="Description of the letter (minimum 25 characters)")
    include_qr_code: Optional[StrictBool] = Field(default=None, description="Flag indicating whether to include a QR code", alias="includeQRCode")
    type: StrictStr
    __properties: ClassVar[List[str]] = ["description", "includeQRCode", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['VISA_APPLICATION_FOR_PERSONAL_TRIP', 'VISA_APPLICATION_FOR_BUSINESS_TRIP', 'VISA_RENEWAL_CERTIFICATE', 'NO_OBJECTION_CERTIFICATE_FOR_TRAVELLING', 'BANK_VERIFICATION_OR_SALARY_CERTIFICATE', 'CUSTOMISED']):
            raise ValueError("must be one of enum values ('VISA_APPLICATION_FOR_PERSONAL_TRIP', 'VISA_APPLICATION_FOR_BUSINESS_TRIP', 'VISA_RENEWAL_CERTIFICATE', 'NO_OBJECTION_CERTIFICATE_FOR_TRAVELLING', 'BANK_VERIFICATION_OR_SALARY_CERTIFICATE', 'CUSTOMISED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LetterRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LetterRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "includeQRCode": obj.get("includeQRCode"),
            "type": obj.get("type")
        })
        return _obj


