# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from dima_sdk.models.invoice_adjustment_status_enum import InvoiceAdjustmentStatusEnum
from dima_sdk.models.off_cycle_payment_reported_by import OffCyclePaymentReportedBy
from typing import Optional, Set
from typing_extensions import Self

class OffCyclePayment(BaseModel):
    """
    OffCyclePayment
    """ # noqa: E501
    id: StrictStr = Field(description="Unique identifier of this resource.")
    status: Optional[InvoiceAdjustmentStatusEnum]
    description: StrictStr = Field(description="Description of the off-cycle payment entry.")
    date_submitted: datetime = Field(description="Long date-time format following ISO-8601")
    currency_code: Annotated[str, Field(min_length=3, strict=True, max_length=3)]
    amount: StrictStr = Field(description="Amount of off-cycle payment.")
    created_at: datetime = Field(description="Long date-time format following ISO-8601")
    reported_by: OffCyclePaymentReportedBy
    __properties: ClassVar[List[str]] = ["id", "status", "description", "date_submitted", "currency_code", "amount", "created_at", "reported_by"]

    @field_validator('currency_code')
    def currency_code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[A-Z]{3}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{3}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OffCyclePayment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of reported_by
        if self.reported_by:
            _dict['reported_by'] = self.reported_by.to_dict()
        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OffCyclePayment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "status": obj.get("status"),
            "description": obj.get("description"),
            "date_submitted": obj.get("date_submitted"),
            "currency_code": obj.get("currency_code"),
            "amount": obj.get("amount"),
            "created_at": obj.get("created_at"),
            "reported_by": OffCyclePaymentReportedBy.from_dict(obj["reported_by"]) if obj.get("reported_by") is not None else None
        })
        return _obj


