# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OnboardingTrackerHrisProfileOidGet200ResponseDataContract(BaseModel):
    """
    OnboardingTrackerHrisProfileOidGet200ResponseDataContract
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique contract ID")
    oid: Optional[StrictStr] = Field(default=None, description="Contract OID")
    name: Optional[StrictStr] = Field(default=None, description="Contract name")
    status: Optional[StrictStr] = Field(default=None, description="Contract status (e.g., in_progress)")
    created_at: Optional[datetime] = Field(default=None, description="Contract creation timestamp")
    first_sign: Optional[StrictStr] = Field(default=None, description="The first sign (either 'client' or 'contractor')")
    completion_date: Optional[datetime] = Field(default=None, description="The completion date of the contract, if applicable")
    client_signed_at: Optional[datetime] = Field(default=None, description="Timestamp when the client signed the contract")
    contractor_signed_at: Optional[datetime] = Field(default=None, description="Timestamp when the contractor signed the contract")
    invited_contractor_email: Optional[StrictStr] = Field(default=None, description="Email of the invited contractor")
    __properties: ClassVar[List[str]] = ["id", "oid", "name", "status", "created_at", "first_sign", "completion_date", "client_signed_at", "contractor_signed_at", "invited_contractor_email"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OnboardingTrackerHrisProfileOidGet200ResponseDataContract from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if completion_date (nullable) is None
        # and model_fields_set contains the field
        if self.completion_date is None and "completion_date" in self.model_fields_set:
            _dict['completion_date'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OnboardingTrackerHrisProfileOidGet200ResponseDataContract from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "oid": obj.get("oid"),
            "name": obj.get("name"),
            "status": obj.get("status"),
            "created_at": obj.get("created_at"),
            "first_sign": obj.get("first_sign"),
            "completion_date": obj.get("completion_date"),
            "client_signed_at": obj.get("client_signed_at"),
            "contractor_signed_at": obj.get("contractor_signed_at"),
            "invited_contractor_email": obj.get("invited_contractor_email")
        })
        return _obj


