# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class PAYGTASKSAllOfCompensationDetails(BaseModel):
    """
    PAYGTASKSAllOfCompensationDetails
    """ # noqa: E501
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Amount to be paid. This field can be excluded when creating a Pay-as-you-go task-based or Milestone contracts.")
    cycle_end: Union[Annotated[float, Field(le=31, strict=True, ge=1)], Annotated[int, Field(le=31, strict=True, ge=1)]] = Field(description="Date invoice cycle ends.")
    frequency: StrictStr = Field(description="Scale of the invoice cycle.")
    currency_code: Annotated[str, Field(min_length=3, strict=True, max_length=3)] = Field(description="Currency code.")
    first_payment: Optional[Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]]] = Field(default=0, description="First payment amount.")
    notice_period: Optional[Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]]] = Field(default=0, description="Days before to notice the termination of contract for eather party.")
    cycle_end_type: StrictStr = Field(description="Cycle end can be weekly 1-7 (Monday = 1) or monthly 1-31.")
    payment_due_days: Union[Annotated[float, Field(le=90, strict=True, ge=0)], Annotated[int, Field(le=90, strict=True, ge=0)]] = Field(description="Number of days to pay the invoice.")
    payment_due_type: StrictStr = Field(description="Type of payment due. If the payment is due on the last day of month, enter 'WITHIN_MONTH'.")
    first_payment_date: Optional[date] = Field(default=None, description="Short date in format ISO-8601 (YYYY-MM-DD). For example: 2022-12-31.")
    pay_before_weekends: Optional[StrictBool] = Field(default=None, description="If the payment due is on a weekend, pay on Friday.")
    __properties: ClassVar[List[str]] = ["amount", "cycle_end", "frequency", "currency_code", "first_payment", "notice_period", "cycle_end_type", "payment_due_days", "payment_due_type", "first_payment_date", "pay_before_weekends"]

    @field_validator('frequency')
    def frequency_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['weekly', 'monthly', 'biweekly', 'semimonthly', 'calendar-month']):
            raise ValueError("must be one of enum values ('weekly', 'monthly', 'biweekly', 'semimonthly', 'calendar-month')")
        return value

    @field_validator('currency_code')
    def currency_code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[A-Z]{3}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{3}$/")
        return value

    @field_validator('cycle_end_type')
    def cycle_end_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['DAY_OF_WEEK', 'DAY_OF_LAST_WEEK', 'DAY_OF_MONTH']):
            raise ValueError("must be one of enum values ('DAY_OF_WEEK', 'DAY_OF_LAST_WEEK', 'DAY_OF_MONTH')")
        return value

    @field_validator('payment_due_type')
    def payment_due_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['REGULAR', 'WITHIN_MONTH']):
            raise ValueError("must be one of enum values ('REGULAR', 'WITHIN_MONTH')")
        return value

    @field_validator('first_payment_date')
    def first_payment_date_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{4}-\d{2}-\d{2}$", value):
            raise ValueError(r"must validate the regular expression /^\d{4}-\d{2}-\d{2}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PAYGTASKSAllOfCompensationDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if first_payment_date (nullable) is None
        # and model_fields_set contains the field
        if self.first_payment_date is None and "first_payment_date" in self.model_fields_set:
            _dict['first_payment_date'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PAYGTASKSAllOfCompensationDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": obj.get("amount"),
            "cycle_end": obj.get("cycle_end"),
            "frequency": obj.get("frequency"),
            "currency_code": obj.get("currency_code"),
            "first_payment": obj.get("first_payment") if obj.get("first_payment") is not None else 0,
            "notice_period": obj.get("notice_period") if obj.get("notice_period") is not None else 0,
            "cycle_end_type": obj.get("cycle_end_type"),
            "payment_due_days": obj.get("payment_due_days"),
            "payment_due_type": obj.get("payment_due_type") if obj.get("payment_due_type") is not None else 'REGULAR',
            "first_payment_date": obj.get("first_payment_date"),
            "pay_before_weekends": obj.get("pay_before_weekends")
        })
        return _obj


