# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class RequestEorContractResignationMadeByEmployeeRequest(BaseModel):
    """
    RequestEorContractResignationMadeByEmployeeRequest
    """ # noqa: E501
    reason: StrictStr = Field(description="Reason why the contract is being terminated")
    reason_detail: Optional[Annotated[str, Field(strict=True, max_length=5000)]] = Field(default=None, description="Optional field to describe the reason behind the resignation request")
    desired_end_date: Annotated[str, Field(strict=True)] = Field(description="The desired end date of the contract")
    __properties: ClassVar[List[str]] = ["reason", "reason_detail", "desired_end_date"]

    @field_validator('reason')
    def reason_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['EMPLOYEE_IS_MOVING_TO_ANOTHER_COUNTRY', 'MOVING_EMPLOYEE_TO_INTERNAL_ENTITY', 'MOVING_EMPLOYEE_TO_DEEL_PEO', 'EMPLOYEE_FOUND_ANOTHER_JOB', 'EMPLOYEE_NOT_HAPPY_WITH_BENEFITS', 'EMPLOYEE_NOT_HAPPY_WITH_SALARY', 'EMPLOYEE_NOT_HAPPY_WITH_THE_ROLE', 'EMPLOYEE_NOT_HAPPY_WITH_COMPANY_CULTURE', 'EMPLOYEE_NOT_HAPPY_WITH_DEEL', 'EMPLOYEE_PROJECT_ENDED', 'EMPLOYEE_SWITCHING_TO_OTHER_EOR_PROVIDER', 'EMPLOYEE_LEFT_ROLE_FOR_PERSONAL_MATTERS', 'EMPLOYEE_MOVING_FROM_EOR_TO_CONTRACTOR_OR_FREELANCE', 'WORKER_TYPE_CHANGE', 'PREFERRED_NOT_TO_SAY']):
            raise ValueError("must be one of enum values ('EMPLOYEE_IS_MOVING_TO_ANOTHER_COUNTRY', 'MOVING_EMPLOYEE_TO_INTERNAL_ENTITY', 'MOVING_EMPLOYEE_TO_DEEL_PEO', 'EMPLOYEE_FOUND_ANOTHER_JOB', 'EMPLOYEE_NOT_HAPPY_WITH_BENEFITS', 'EMPLOYEE_NOT_HAPPY_WITH_SALARY', 'EMPLOYEE_NOT_HAPPY_WITH_THE_ROLE', 'EMPLOYEE_NOT_HAPPY_WITH_COMPANY_CULTURE', 'EMPLOYEE_NOT_HAPPY_WITH_DEEL', 'EMPLOYEE_PROJECT_ENDED', 'EMPLOYEE_SWITCHING_TO_OTHER_EOR_PROVIDER', 'EMPLOYEE_LEFT_ROLE_FOR_PERSONAL_MATTERS', 'EMPLOYEE_MOVING_FROM_EOR_TO_CONTRACTOR_OR_FREELANCE', 'WORKER_TYPE_CHANGE', 'PREFERRED_NOT_TO_SAY')")
        return value

    @field_validator('desired_end_date')
    def desired_end_date_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^\d{4}-\d{2}-\d{2}$", value):
            raise ValueError(r"must validate the regular expression /^\d{4}-\d{2}-\d{2}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RequestEorContractResignationMadeByEmployeeRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RequestEorContractResignationMadeByEmployeeRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "reason": obj.get("reason"),
            "reason_detail": obj.get("reason_detail"),
            "desired_end_date": obj.get("desired_end_date")
        })
        return _obj


