# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class TimeTrackingShiftSummarySchema(BaseModel):
    """
    Summary of the shift
    """ # noqa: E501
    shift_rate_external_id: StrictStr = Field(description="External ID of the shift rate")
    shift_duration_hours: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Duration of the shift in hours")
    total_break_hours: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total break hours")
    payable_break_hours: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Payable break hours")
    total_payable_hours: Union[StrictFloat, StrictInt] = Field(description="Total payable hours")
    __properties: ClassVar[List[str]] = ["shift_rate_external_id", "shift_duration_hours", "total_break_hours", "payable_break_hours", "total_payable_hours"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TimeTrackingShiftSummarySchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TimeTrackingShiftSummarySchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "shift_rate_external_id": obj.get("shift_rate_external_id"),
            "shift_duration_hours": obj.get("shift_duration_hours"),
            "total_break_hours": obj.get("total_break_hours"),
            "payable_break_hours": obj.get("payable_break_hours"),
            "total_payable_hours": obj.get("total_payable_hours")
        })
        return _obj


