# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Union
from typing import Optional, Set
from typing_extensions import Self

class UpdateGPEmployeeCompensationRequestData(BaseModel):
    """
    UpdateGPEmployeeCompensationRequestData
    """ # noqa: E501
    scale: StrictStr = Field(description="The scale to which a given salary applies.")
    salary: Union[StrictFloat, StrictInt] = Field(description="Compensation salary.")
    effective_date: date = Field(description="Short date in format ISO-8601 (YYYY-MM-DD). For example: 2022-12-31.")
    __properties: ClassVar[List[str]] = ["scale", "salary", "effective_date"]

    @field_validator('scale')
    def scale_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['YEAR', 'MONTH', 'HOUR']):
            raise ValueError("must be one of enum values ('YEAR', 'MONTH', 'HOUR')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateGPEmployeeCompensationRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateGPEmployeeCompensationRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "scale": obj.get("scale"),
            "salary": obj.get("salary"),
            "effective_date": obj.get("effective_date")
        })
        return _obj


