# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class WebhookEventTypeResponse(BaseModel):
    """
    WebhookEventTypeResponse
    """ # noqa: E501
    id: Union[StrictFloat, StrictInt] = Field(description="Event type unique identifier.")
    module_name: StrictStr = Field(description="Name of the rabbit queue.")
    module_label: StrictStr = Field(description="Display name of the rabbit queue in Deel UI.")
    name: StrictStr = Field(description="Name of the webhook event.")
    description: StrictStr = Field(description="Describes the webhook event and other pertinent info.")
    payload_example: Optional[StrictStr] = Field(default=None, description="JSON payload example of the specific event.")
    created_at: Optional[StrictStr] = Field(default=None, description="Time at which the event type was created.")
    updated_at: Optional[StrictStr] = Field(default=None, description="Time at which the event type was updated.")
    __properties: ClassVar[List[str]] = ["id", "module_name", "module_label", "name", "description", "payload_example", "created_at", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WebhookEventTypeResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if payload_example (nullable) is None
        # and model_fields_set contains the field
        if self.payload_example is None and "payload_example" in self.model_fields_set:
            _dict['payload_example'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WebhookEventTypeResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "module_name": obj.get("module_name"),
            "module_label": obj.get("module_label"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "payload_example": obj.get("payload_example"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


