# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class WorkerBankAccountInfo(BaseModel):
    """
    WorkerBankAccountInfo
    """ # noqa: E501
    full_name: Optional[StrictStr] = Field(default=None, description="Full name of the user.")
    phone: Optional[StrictStr] = Field(default=None, description="The user's phone number.")
    address_line1: Optional[StrictStr] = Field(default=None, description="The primary address line.")
    address_line2: Optional[StrictStr] = Field(default=None, description="The secondary address line.")
    city: Optional[StrictStr] = Field(default=None, description="The city of the user's address.")
    province_state: Optional[StrictStr] = Field(default=None, description="The state or province of the user's address.")
    postal: Optional[StrictStr] = Field(default=None, description="The user's postal or ZIP code.")
    bank_name: Optional[StrictStr] = Field(default=None, description="Name of the user's bank.")
    country_code: Optional[StrictStr] = Field(default=None, description="The country code of the user.")
    bank_country_code: Optional[StrictStr] = Field(default=None, description="The country code where the bank is located.")
    swift_bic: Optional[StrictStr] = Field(default=None, description="SWIFT/BIC code for the bank.")
    account_number: Optional[StrictStr] = Field(default=None, description="The user's bank account number.")
    bank_code: Optional[StrictStr] = Field(default=None, description="The bank code.")
    original_name: Optional[StrictStr] = Field(default=None, description="The original name of the user.")
    tax_id: Optional[StrictStr] = Field(default=None, description="The user's tax identification number.")
    branch_code: Optional[StrictStr] = Field(default=None, description="The branch code of the user's bank.")
    currency_code: Optional[StrictStr] = Field(default=None, description="The currency code for transactions.")
    bank_branch_name: Optional[StrictStr] = Field(default=None, description="The name of the user's bank branch.")
    iban: Optional[StrictStr] = Field(default=None, description="The International Bank Account Number (IBAN).")
    email: Optional[StrictStr] = Field(default=None, description="The user's email address.")
    rib_number: Optional[StrictStr] = Field(default=None, description="The RIB(Relevé d'Identité Bancaire).")
    account_type: Optional[StrictStr] = Field(default=None, description="Bank account type.")
    ach_routing_number: Optional[StrictStr] = Field(default=None, description="The ACH (Automated Clearing House) Routing Number.")
    id: StrictStr = Field(description="Unique identifier of this resource.")
    created_at: datetime = Field(description="Long date-time format following ISO-8601")
    updated_at: datetime = Field(description="Long date-time format following ISO-8601")
    status: Optional[StrictStr] = Field(default=None, description="Current status of bank account")
    __properties: ClassVar[List[str]] = ["full_name", "phone", "address_line1", "address_line2", "city", "province_state", "postal", "bank_name", "country_code", "bank_country_code", "swift_bic", "account_number", "bank_code", "original_name", "tax_id", "branch_code", "currency_code", "bank_branch_name", "iban", "email", "rib_number", "account_type", "ach_routing_number", "id", "created_at", "updated_at", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkerBankAccountInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkerBankAccountInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "full_name": obj.get("full_name"),
            "phone": obj.get("phone"),
            "address_line1": obj.get("address_line1"),
            "address_line2": obj.get("address_line2"),
            "city": obj.get("city"),
            "province_state": obj.get("province_state"),
            "postal": obj.get("postal"),
            "bank_name": obj.get("bank_name"),
            "country_code": obj.get("country_code"),
            "bank_country_code": obj.get("bank_country_code"),
            "swift_bic": obj.get("swift_bic"),
            "account_number": obj.get("account_number"),
            "bank_code": obj.get("bank_code"),
            "original_name": obj.get("original_name"),
            "tax_id": obj.get("tax_id"),
            "branch_code": obj.get("branch_code"),
            "currency_code": obj.get("currency_code"),
            "bank_branch_name": obj.get("bank_branch_name"),
            "iban": obj.get("iban"),
            "email": obj.get("email"),
            "rib_number": obj.get("rib_number"),
            "account_type": obj.get("account_type"),
            "ach_routing_number": obj.get("ach_routing_number"),
            "id": obj.get("id"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "status": obj.get("status")
        })
        return _obj


