# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from dima_sdk.models.alternate_email_item import AlternateEmailItem
from dima_sdk.models.worker_legal_entity import WorkerLegalEntity
from typing import Optional, Set
from typing_extensions import Self

class WorkerOfContract(BaseModel):
    """
    WorkerOfContract
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier of this resource.")
    full_name: Optional[Annotated[str, Field(min_length=1, strict=True)]] = Field(default=None, description="Worker's full name.")
    email: Optional[Annotated[str, Field(min_length=5, strict=True)]] = Field(default=None, description="User's email address.")
    alternate_email: Optional[List[AlternateEmailItem]] = Field(default=None, description="List of alternate email addresses.")
    nationality: Optional[StrictStr] = Field(default=None, description="Worker's nationality.")
    image: Optional[StrictStr] = None
    legal_entity: Optional[WorkerLegalEntity] = None
    date_of_birth: Optional[datetime] = Field(default=None, description="Long date-time format following ISO-8601")
    expected_email: Optional[Annotated[str, Field(min_length=5, strict=True)]] = Field(default=None, description="Worker's email address.")
    first_name: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Worker's first name")
    last_name: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Worker's last name")
    country: Optional[StrictStr] = Field(default=None, description="Worker's country (location not nationality)")
    __properties: ClassVar[List[str]] = ["id", "full_name", "email", "alternate_email", "nationality", "image", "legal_entity", "date_of_birth", "expected_email", "first_name", "last_name", "country"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkerOfContract from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in alternate_email (list)
        _items = []
        if self.alternate_email:
            for _item_alternate_email in self.alternate_email:
                if _item_alternate_email:
                    _items.append(_item_alternate_email.to_dict())
            _dict['alternate_email'] = _items
        # override the default output from pydantic by calling `to_dict()` of legal_entity
        if self.legal_entity:
            _dict['legal_entity'] = self.legal_entity.to_dict()
        # set to None if email (nullable) is None
        # and model_fields_set contains the field
        if self.email is None and "email" in self.model_fields_set:
            _dict['email'] = None

        # set to None if nationality (nullable) is None
        # and model_fields_set contains the field
        if self.nationality is None and "nationality" in self.model_fields_set:
            _dict['nationality'] = None

        # set to None if date_of_birth (nullable) is None
        # and model_fields_set contains the field
        if self.date_of_birth is None and "date_of_birth" in self.model_fields_set:
            _dict['date_of_birth'] = None

        # set to None if expected_email (nullable) is None
        # and model_fields_set contains the field
        if self.expected_email is None and "expected_email" in self.model_fields_set:
            _dict['expected_email'] = None

        # set to None if first_name (nullable) is None
        # and model_fields_set contains the field
        if self.first_name is None and "first_name" in self.model_fields_set:
            _dict['first_name'] = None

        # set to None if last_name (nullable) is None
        # and model_fields_set contains the field
        if self.last_name is None and "last_name" in self.model_fields_set:
            _dict['last_name'] = None

        # set to None if country (nullable) is None
        # and model_fields_set contains the field
        if self.country is None and "country" in self.model_fields_set:
            _dict['country'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkerOfContract from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "full_name": obj.get("full_name"),
            "email": obj.get("email"),
            "alternate_email": [AlternateEmailItem.from_dict(_item) for _item in obj["alternate_email"]] if obj.get("alternate_email") is not None else None,
            "nationality": obj.get("nationality"),
            "image": obj.get("image"),
            "legal_entity": WorkerLegalEntity.from_dict(obj["legal_entity"]) if obj.get("legal_entity") is not None else None,
            "date_of_birth": obj.get("date_of_birth"),
            "expected_email": obj.get("expected_email"),
            "first_name": obj.get("first_name"),
            "last_name": obj.get("last_name"),
            "country": obj.get("country")
        })
        return _obj


