# coding: utf-8

"""
    Deel REST API

    Deel REST API

    The version of the OpenAPI document: 1.25.0
    Contact: apiteam@deel.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from dima_sdk.models.breakdown_costs_quote import BreakdownCostsQuote
from typing import Optional, Set
from typing_extensions import Self

class EorQuotePayload(BaseModel):
    """
    EOR quote approved by Deel
    """ # noqa: E501
    annual_salary: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Annual Salary in local currency")
    currency: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = None
    breakdown_costs: Optional[BreakdownCostsQuote] = None
    severance_accrual_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total severance accrual in local currency")
    severance_accrual_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total severance accrual in USD")
    recurring_allowance_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total recurring allowance in local currency")
    recurring_allowance_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total recurring allowance in USD")
    salary_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total salary in local currency")
    salary_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total salary in USD")
    employer_cost_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total employer cost in local currency")
    employer_cost_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total employer cost in USD")
    platform_fee_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total platform fee in local currency")
    platform_fee_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total platform fee in USD")
    mobility_fee_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total mobility fee in local currency")
    mobility_fee_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total mobility fee in USD")
    monthly_cost_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total monthly cost in local currency")
    monthly_cost_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total monthly cost in USD")
    gross_salary_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total gross salary in local currency")
    gross_salary_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total gross salary in USD")
    cba_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total CBA in local currency")
    cba_total_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total CBA in USD")
    created_at: Optional[datetime] = Field(default=None, description="Long date-time format following ISO-8601")
    updated_at: Optional[datetime] = Field(default=None, description="Long date-time format following ISO-8601")
    contract_id: Optional[StrictStr] = Field(default=None, description="Contract id")
    contract_name: Optional[StrictStr] = Field(default=None, description="Contract name")
    country_code: Optional[Annotated[str, Field(min_length=2, strict=True, max_length=2)]] = Field(default=None, description="Country code.")
    country_name: Optional[StrictStr] = Field(default=None, description="Country Name")
    __properties: ClassVar[List[str]] = ["annual_salary", "currency", "breakdown_costs", "severance_accrual_total", "severance_accrual_total_usd", "recurring_allowance_total", "recurring_allowance_total_usd", "salary_total", "salary_total_usd", "employer_cost_total", "employer_cost_total_usd", "platform_fee_total", "platform_fee_total_usd", "mobility_fee_total", "mobility_fee_total_usd", "monthly_cost_total", "monthly_cost_total_usd", "gross_salary_total", "gross_salary_total_usd", "cba_total", "cba_total_usd", "created_at", "updated_at", "contract_id", "contract_name", "country_code", "country_name"]

    @field_validator('currency')
    def currency_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Z]{3}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{3}$/")
        return value

    @field_validator('country_code')
    def country_code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Z]{2}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{2}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EorQuotePayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of breakdown_costs
        if self.breakdown_costs:
            _dict['breakdown_costs'] = self.breakdown_costs.to_dict()
        # set to None if created_at (nullable) is None
        # and model_fields_set contains the field
        if self.created_at is None and "created_at" in self.model_fields_set:
            _dict['created_at'] = None

        # set to None if updated_at (nullable) is None
        # and model_fields_set contains the field
        if self.updated_at is None and "updated_at" in self.model_fields_set:
            _dict['updated_at'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EorQuotePayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "annual_salary": obj.get("annual_salary"),
            "currency": obj.get("currency"),
            "breakdown_costs": BreakdownCostsQuote.from_dict(obj["breakdown_costs"]) if obj.get("breakdown_costs") is not None else None,
            "severance_accrual_total": obj.get("severance_accrual_total"),
            "severance_accrual_total_usd": obj.get("severance_accrual_total_usd"),
            "recurring_allowance_total": obj.get("recurring_allowance_total"),
            "recurring_allowance_total_usd": obj.get("recurring_allowance_total_usd"),
            "salary_total": obj.get("salary_total"),
            "salary_total_usd": obj.get("salary_total_usd"),
            "employer_cost_total": obj.get("employer_cost_total"),
            "employer_cost_total_usd": obj.get("employer_cost_total_usd"),
            "platform_fee_total": obj.get("platform_fee_total"),
            "platform_fee_total_usd": obj.get("platform_fee_total_usd"),
            "mobility_fee_total": obj.get("mobility_fee_total"),
            "mobility_fee_total_usd": obj.get("mobility_fee_total_usd"),
            "monthly_cost_total": obj.get("monthly_cost_total"),
            "monthly_cost_total_usd": obj.get("monthly_cost_total_usd"),
            "gross_salary_total": obj.get("gross_salary_total"),
            "gross_salary_total_usd": obj.get("gross_salary_total_usd"),
            "cba_total": obj.get("cba_total"),
            "cba_total_usd": obj.get("cba_total_usd"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "contract_id": obj.get("contract_id"),
            "contract_name": obj.get("contract_name"),
            "country_code": obj.get("country_code"),
            "country_name": obj.get("country_name")
        })
        return _obj


